function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
    local ix,iy = 1,1
    local SY,DY = 1,.2

    self:add_rendering()    --todo why we get remdering from layer_c ???
	self:add_camera()
end

function meu:draw()
    self:draw_layers_begin()
        --  self:print( aaa.time.t )
        --self:draw_layer( 1 )
        self:draw_1( self:get_alpha(), 10, false )       -- choose the drawing function here
        self:draw_2( self:get_alpha(), 10, false )       -- choose the drawing function here
        -- self:draw_7( self:get_alpha(), 10, false )       -- choose the drawing function here
        self:draw_10( self:get_alpha(), 10, false )       -- choose the drawing function here
        self:draw_8( self:get_alpha(), 10, false )       -- choose the drawing function here
        self:draw_9( self:get_alpha(), 10, false )       -- choose the drawing function here
    self:draw_layers_end()

end

-- documentation is in
--  AAADoc/lua_aaaseed_draw.lua
--  AAADoc/lua_aaaseed_interface.lua

-- Hello world
function meu:draw_1( alpha )
    gol.color_white( alpha )
    aaa.draw_str( "Bonjour\nil est "..os.date("%H:%M:%S") )
end
-- Flash
function meu:draw_2( alpha ) 
    gol.color_white( (math.sin(aaa.time.t * 10.) * .5 + .5) * alpha )
    aaa.draw_str( "Flash" )
end
-- Rectangle
function meu:draw_3( alpha )
    gol.color_green( alpha )
    aaa.draw_rect_line( -1,-1, 2,2 )
end
-- Rectangles
function meu:draw_4( alpha, nb_factor )
    gol.color_yellow( alpha )
    local nb = 100 * nb_factor
    local size = 8
    local d = size/(nb-1)
    math.randomseed(42)
    for i=1,nb do
        local x = -size/2 + size * (i-1)/(nb-1)
        aaa.draw_rect_line( x,0, x+d,math.random()*2 )
    end
end
-- more Rectangles
function meu:draw_5( alpha, nb_factor )
    local nb_y = 8 * nb_factor
    local size_y = 8
    local d_y = size_y/(nb_y-1)

    local nb_x = 8 * nb_factor 
    local size_x = 8
    local d_x = size_x/(nb_x-1)
    math.randomseed(42)

    for iy=1,nb_y do
        local y = -size_y/2 + size_y * (iy-1)/(nb_y-1)
        for ix=1,nb_x do
            local x = -size_x/2 + size_x * (ix-1)/(nb_x-1)
            local rnd = math.random()
            --rnd = math.pow( rnd, 4 ) * 4.
            local d = rnd * d_y * .5
            d = d * (math.sin( -aaa.time.t * 5. + iy / 3. ) * .25 + .75 )
            local r,g,b = math.random(), math.random(), math.random()
            gol.color( r,g,b, alpha )  -- red green blue alpha
            --gol.color( r*rnd,g*rnd,b*rnd )
            aaa.draw_rect( x-d,y-d, x+d,y+d)
        end
    end
end
-- Some 3d
local function get_color()
    local r = math.random()
    local g = math.random()
    local b = math.random()
    local gam = 1.
    return math.pow(r,gam), math.pow(g,gam), math.pow(b,gam)
end
function meu:draw_6( alpha, nb_factor, b_rotate )
    local nb = 160 * nb_factor * nb_factor
    local size = 8
    math.randomseed(42)
    for i=1,nb do
        local x = size * (math.random() - .5)  
        local y = size * (math.random() - .5)  
        local z = size * math.random() * .1
        local r,g,b = get_color()
        gol.color( r,g,b, alpha )
         --gol.color( r*rnd,g*rnd,b*rnd )
        gol.push_matrix()
            gol.translate( x,y,z )
            if b_rotate then
                gol.rotate_y( math.random() )
                gol.rotate_x( math.random() )
            end
            local s = .5
            local sx = math.random() * s
            local sy = math.random() * s
            local sz = math.random() * s       
            aaa.draw_box( sx,sy,sz )
        gol.pop_matrix()
    end 
end
--line geometry
function meu:draw_6()
	gol.set_line_width( 1 )
	self:set_icon_color()
		local L = -.4
		-- aaa.draw_rect( L, -.25, L+.16, .25 )
		gol.draw_line_loop_2d(	L, -.1,
								L - .05, -.3,
								L - .05, .3,
								L, .1
							)
	gol.color_white()
	BU:set_text_line_attr()
end
function meu:draw_7()
	gol.set_line_width( 1 )
	self:set_icon_color()
		local L = 0
		-- aaa.draw_rect( L, -.25, L+.16, .25 )
		gol.draw_line_loop_2d(	.5 , 1.0,
								0, .75,
								0, .25,
								.5, 0,
                                1, .25,
                                1, .75
							)

end

-- line 
function meu:draw_8()
    gol.set_line_width( 1 )
    self:set_icon_color()
    gol.draw_line_loop_3d( 
        0.483722, 0.000000, -1.273885, ---switch row 1 and 2 for an hexagon when you get the obj data
        0.609600, 0.000000, -1.055858, ---switch row 1 and 2 for an hexagon when you get the obj data
        0.861356, 0.000000, -1.055858,
        0.987234, 0.000000, -1.273885,
        0.861356, 0.000000, -1.491912,
        0.609600, 0.000000, -1.491912

    )

    gol.draw_line_loop_3d( 
        0.609600, 0.000000, 1.055858, ---switch row 1 and 2 for an hexagon when you get the obj data
        1.219200, 0.000000, 0.000000, ---switch row 1 and 2 for an hexagon when you get the obj data
        0.609600, 0.000000, -1.055858,
        -0.609600, 0.000000, -1.055858,
        -1.219200, 0.000000, 0.000000,
        -0.609600, 0.000000, 1.055858
    )

    gol.draw_line_loop_3d( 
    .4227411, 1.046799, 0, 
    .7218056, 1.799822, 0, 
   
    .219201, 2.43533, 0, -.582468, 2.317816, 0, -.8815324, 1.564794, 0, -.3789279, .9292849, 0
    )



    gol.draw_lines_3d( 
        -0.609600, 0.000000, -1.055858,
        -0.735478, 0.000000, -1.273885,
        0.609600, 0.000000, 1.055858,
        0.735478, 0.000000, 1.273885,
        -0.735478, 0.000000, 1.273885,
        -0.609600, 0.000000, 1.055858,
        1.470956, 0.000000, 0.000000,
        1.219199, 0.000000, 0.000000,
        -1.219200, 0.000000, 0.000000,
        -1.470956, 0.000000, 0.000000
        
    )
      gol.color_white()
      BU:set_text_line_attr()

end

function meu:draw_10()
  
    self:set_icon_color()
    gol.draw_lines_3d( 
    -2.5, -2.25, -2.0,
    -1.5, -2.25, -7.0,
      2.5, -2.25, -2.75,
      -1.5, -2.25, -7.0,
      2.5, -2.25, -2.75,
      0, 4.5, -5.0,
      0, 4.5, -5.0,
      -2.5, -2.25, -2.0,
      -2.5, -2.25, -2.0,
      2.5, -2.25, -2.75,
      -1.5, -2.25, -7.0,
      0, 4.5, -5.0

      
    )
      gol.color_white()
      BU:set_text_line_attr()

end

function meu:draw_9()
   ---gol.translate(0, -1, 0)
    gol.set_line_width( 4 )
    self:set_icon_color()
    gol.draw_line_loop_3d(
-0.527929, 0.137160, -0.381000,
-0.593920, 0.171450, -0.419100,
-0.659911, 0.188595, -0.381000,
-0.659911, 0.171450, -0.304800,
-0.593920, 0.137160, -0.266700,
-0.527929, 0.120015, -0.304800
)
gol.draw_line_loop_3d(
-0.461938, 0.148590, -0.495300,
-0.461938, 0.125730, -0.419100,
-0.395947, 0.097155, -0.381000,
-0.329956, 0.091440, -0.419100,
-0.329956, 0.114300, -0.495300,
-0.395947, 0.142875, -0.533400
)
gol.draw_line_loop_3d(
-0.131982, 0.125730, -0.609600,
-0.197973, 0.148590, -0.647700,
-0.263964, 0.142875, -0.609600,
-0.263964, 0.114300, -0.533400,
-0.197973, 0.091440, -0.495300,
-0.131982, 0.097155, -0.533400
)
gol.draw_line_loop_3d(
0.065991, 0.171450, -0.723900,
0.000000, 0.188595, -0.762000,
-0.065991, 0.171450, -0.723900,
-0.065991, 0.137160, -0.647700,
0.000000, 0.120015, -0.609600,
0.065991, 0.137160, -0.647700
)
gol.draw_line_loop_3d(
0.197973, 0.148590, -0.647700,
0.131982, 0.125730, -0.609600,
0.131982, 0.097155, -0.533400,
0.197973, 0.091440, -0.495300,
0.263965, 0.114300, -0.533400,
0.263965, 0.142875, -0.609600
)
gol.draw_line_loop_3d(
0.065991, 0.080010, -0.495300,
0.000000, 0.091440, -0.533400,
-0.065991, 0.080010, -0.495300,
-0.065991, 0.057150, -0.419100,
0.000000, 0.045720, -0.381000,
0.065991, 0.057150, -0.419100
)
gol.draw_line_loop_3d(
-0.197973, 0.068580, -0.419100,
-0.263964, 0.068580, -0.381000,
-0.263964, 0.051435, -0.304800,
-0.197973, 0.034290, -0.266700,
-0.131982, 0.034290, -0.304800,
-0.131982, 0.051435, -0.381000
)
gol.draw_line_loop_3d(
-0.395947, 0.057150, -0.152400,
-0.329956, 0.045720, -0.190500,
-0.329956, 0.057150, -0.266700,
-0.395947, 0.080010, -0.304800,
-0.461938, 0.091440, -0.266700,
-0.461938, 0.080010, -0.190500
)
gol.draw_line_loop_3d(
-0.593920, 0.125730, -0.190500,
-0.659911, 0.148590, -0.152400,
-0.659911, 0.142875, -0.076200,
-0.593920, 0.114300, -0.038100,
-0.527929, 0.091440, -0.076200,
-0.527929, 0.097155, -0.152400
)
gol.draw_line_loop_3d(
-0.659911, 0.148590, 0.152400,
-0.593920, 0.125730, 0.190500,
-0.527929, 0.097155, 0.152400,
-0.527929, 0.091440, 0.076200,
-0.593920, 0.114300, 0.038100,
-0.659911, 0.142875, 0.076200
)
gol.draw_line_loop_3d(
-0.461938, 0.068580, -0.038100,
-0.461938, 0.068580, 0.038100,
-0.395947, 0.051435, 0.076200,
-0.329956, 0.034290, 0.038100,
-0.329956, 0.034290, -0.038100,
-0.395947, 0.051435, -0.076200
)
gol.draw_line_loop_3d(
-0.197973, 0.022860, -0.190500,
-0.263964, 0.028575, -0.152400,
-0.263964, 0.022860, -0.076200,
-0.197973, 0.011430, -0.038100,
-0.131982, 0.005715, -0.076200,
-0.131982, 0.011430, -0.152400
)
gol.draw_line_loop_3d(
0.065991, 0.022860, -0.266700,
0.000000, 0.028575, -0.304800,
-0.065991, 0.022860, -0.266700,
-0.065991, 0.011430, -0.190500,
0.000000, 0.005715, -0.152400,
0.065991, 0.011430, -0.190500
)
gol.draw_line_loop_3d(
0.263965, 0.068580, -0.381000,
0.197973, 0.068580, -0.419100,
0.131982, 0.051435, -0.381000,
0.131982, 0.034290, -0.304800,
0.197973, 0.034290, -0.266700,
0.263965, 0.051435, -0.304800
)
gol.draw_line_loop_3d(
0.461938, 0.125730, -0.419100,
0.461938, 0.148590, -0.495300,
0.395947, 0.142875, -0.533400,
0.329956, 0.114300, -0.495300,
0.329956, 0.091440, -0.419100,
0.395947, 0.097155, -0.381000
)
gol.draw_line_loop_3d(
0.593920, 0.171450, -0.419100,
0.527929, 0.137160, -0.381000,
0.527929, 0.120015, -0.304800,
0.593920, 0.137160, -0.266700,
0.659911, 0.171450, -0.304800,
0.659911, 0.188595, -0.381000
)
gol.draw_line_loop_3d(
0.461938, 0.080010, -0.190500,
0.461938, 0.091440, -0.266700,
0.395947, 0.080010, -0.304800,
0.329956, 0.057150, -0.266700,
0.329956, 0.045720, -0.190500,
0.395947, 0.057150, -0.152400
)
gol.draw_line_loop_3d(
0.131982, 0.011430, -0.152400,
0.131982, 0.005715, -0.076200,
0.197973, 0.011430, -0.038100,
0.263965, 0.022860, -0.076200,
0.263965, 0.028575, -0.152400,
0.197973, 0.022860, -0.190500
)
gol.draw_line_loop_3d(
0.000000, 0.000000, -0.076200,
-0.065991, 0.000000, -0.038100,
-0.065991, 0.000000, 0.038100,
0.000000, 0.000000, 0.076200,
0.065991, 0.000000, 0.038100,
0.065991, 0.000000, -0.038100
)
gol.draw_line_loop_3d(
-0.131982, 0.011430, 0.152400,
-0.131982, 0.005715, 0.076200,
-0.197973, 0.011430, 0.038100,
-0.263964, 0.022860, 0.076200,
-0.263964, 0.028575, 0.152400,
-0.197973, 0.022860, 0.190500
)
gol.draw_line_loop_3d(
-0.461938, 0.080010, 0.190500,
-0.461938, 0.091440, 0.266700,
-0.395947, 0.080010, 0.304800,
-0.329956, 0.057150, 0.266700,
-0.329956, 0.045720, 0.190500,
-0.395947, 0.057150, 0.152400
)
gol.draw_line_loop_3d(
-0.593920, 0.171450, 0.419100,
-0.527929, 0.137160, 0.381000,
-0.527929, 0.120015, 0.304800,
-0.593920, 0.137160, 0.266700,
-0.659911, 0.171450, 0.304800,
-0.659911, 0.188595, 0.381000
)
gol.draw_line_loop_3d(
-0.461938, 0.125730, 0.419100,
-0.461938, 0.148590, 0.495300,
-0.395947, 0.142875, 0.533400,
-0.329956, 0.114300, 0.495300,
-0.329956, 0.091440, 0.419100,
-0.395947, 0.097155, 0.381000
)
gol.draw_line_loop_3d(
-0.263964, 0.068580, 0.381000,
-0.197973, 0.068580, 0.419100,
-0.131982, 0.051435, 0.381000,
-0.131982, 0.034290, 0.304800,
-0.197973, 0.034290, 0.266700,
-0.263964, 0.051435, 0.304800
)
gol.draw_line_loop_3d(
0.065991, 0.011430, 0.190500,
0.000000, 0.005715, 0.152400,
-0.065991, 0.011430, 0.190500,
-0.065991, 0.022860, 0.266700,
0.000000, 0.028575, 0.304800,
0.065991, 0.022860, 0.266700
)
gol.draw_line_loop_3d(
0.197973, 0.022860, 0.190500,
0.263965, 0.028575, 0.152400,
0.263965, 0.022860, 0.076200,
0.197973, 0.011430, 0.038100,
0.131982, 0.005715, 0.076200,
0.131982, 0.011430, 0.152400
)
gol.draw_line_loop_3d(
0.461938, 0.068580, 0.038100,
0.461938, 0.068580, -0.038100,
0.395947, 0.051435, -0.076200,
0.329956, 0.034290, -0.038100,
0.329956, 0.034290, 0.038100,
0.395947, 0.051435, 0.076200
)
gol.draw_line_loop_3d(
0.659911, 0.148590, -0.152400,
0.593920, 0.125730, -0.190500,
0.527929, 0.097155, -0.152400,
0.527929, 0.091440, -0.076200,
0.593920, 0.114300, -0.038100,
0.659911, 0.142875, -0.076200
)
gol.draw_line_loop_3d(
0.593920, 0.125730, 0.190500,
0.659911, 0.148590, 0.152400,
0.659911, 0.142875, 0.076200,
0.593920, 0.114300, 0.038100,
0.527929, 0.091440, 0.076200,
0.527929, 0.097155, 0.152400
)
gol.draw_line_loop_3d(
0.395947, 0.057150, 0.152400,
0.329956, 0.045720, 0.190500,
0.329956, 0.057150, 0.266700,
0.395947, 0.080010, 0.304800,
0.461938, 0.091440, 0.266700,
0.461938, 0.080010, 0.190500
)
gol.draw_line_loop_3d(
0.197973, 0.068580, 0.419100,
0.263965, 0.068580, 0.381000,
0.263965, 0.051435, 0.304800,
0.197973, 0.034290, 0.266700,
0.131982, 0.034290, 0.304800,
0.131982, 0.051435, 0.381000
)
gol.draw_line_loop_3d(
0.065991, 0.057150, 0.419100,
0.000000, 0.045720, 0.381000,
-0.065991, 0.057150, 0.419100,
-0.065991, 0.080010, 0.495300,
0.000000, 0.091440, 0.533400,
0.065991, 0.080010, 0.495300
)
gol.draw_line_loop_3d(
-0.197973, 0.148590, 0.647700,
-0.131982, 0.125730, 0.609600,
-0.131982, 0.097155, 0.533400,
-0.197973, 0.091440, 0.495300,
-0.263964, 0.114300, 0.533400,
-0.263964, 0.142875, 0.609600
)
gol.draw_line_loop_3d(
0.065991, 0.137160, 0.647700,
0.000000, 0.120015, 0.609600,
-0.065991, 0.137160, 0.647700,
-0.065991, 0.171450, 0.723900,
0.000000, 0.188595, 0.762000,
0.065991, 0.171450, 0.723900
)
gol.draw_line_loop_3d(
0.131982, 0.125730, 0.609600,
0.197973, 0.148590, 0.647700,
0.263965, 0.142875, 0.609600,
0.263965, 0.114300, 0.533400,
0.197973, 0.091440, 0.495300,
0.131982, 0.097155, 0.533400
)
gol.draw_line_loop_3d(
0.461938, 0.148590, 0.495300,
0.461938, 0.125730, 0.419100,
0.395947, 0.097155, 0.381000,
0.329956, 0.091440, 0.419100,
0.329956, 0.114300, 0.495300,
0.395947, 0.142875, 0.533400
)
gol.draw_line_loop_3d(
0.527929, 0.137160, 0.381000,
0.593920, 0.171450, 0.419100,
0.659911, 0.188595, 0.381000,
0.659911, 0.171450, 0.304800,
0.593920, 0.137160, 0.266700,
0.527929, 0.120015, 0.304800
)
gol.draw_line_loop_3d(
-0.593920, 0.137160, -0.266700,
-0.593920, 0.125730, -0.190500,
-0.527929, 0.097155, -0.152400,
-0.461938, 0.080010, -0.190500,
-0.461938, 0.091440, -0.266700,
-0.527929, 0.120015, -0.304800
)
gol.draw_line_loop_3d(
-0.263965, 0.068580, -0.381000,
-0.329956, 0.091440, -0.419100,
-0.395947, 0.097155, -0.381000,
-0.395947, 0.080010, -0.304800,
-0.329956, 0.057150, -0.266700,
-0.263965, 0.051435, -0.304800
)
gol.draw_line_loop_3d(
-0.197973, 0.091440, -0.495300,
-0.197973, 0.068580, -0.419100,
-0.131982, 0.051435, -0.381000,
-0.065991, 0.057150, -0.419100,
-0.065991, 0.080010, -0.495300,
-0.131982, 0.097155, -0.533400
)
gol.draw_line_loop_3d(
0.131982, 0.125730, -0.609600,
0.065991, 0.137160, -0.647700,
-0.000000, 0.120015, -0.609600,
-0.000000, 0.091440, -0.533400,
0.065991, 0.080010, -0.495300,
0.131982, 0.097155, -0.533400
)
gol.draw_line_loop_3d(
0.263965, 0.114300, -0.533400,
0.197973, 0.091440, -0.495300,
0.197973, 0.068580, -0.419100,
0.263965, 0.068580, -0.381000,
0.329956, 0.091440, -0.419100,
0.329956, 0.114300, -0.495300
)
gol.draw_line_loop_3d(
0.065991, 0.057150, -0.419100,
-0.000000, 0.045720, -0.381000,
-0.000000, 0.028575, -0.304800,
0.065991, 0.022860, -0.266700,
0.131982, 0.034290, -0.304800,
0.131982, 0.051435, -0.381000
)
gol.draw_line_loop_3d(
-0.197973, 0.034290, -0.266700,
-0.197973, 0.022860, -0.190500,
-0.131982, 0.011430, -0.152400,
-0.065991, 0.011430, -0.190500,
-0.065991, 0.022860, -0.266700,
-0.131982, 0.034290, -0.304800
)
gol.draw_line_loop_3d(
-0.329956, 0.045720, -0.190500,
-0.395947, 0.057150, -0.152400,
-0.395947, 0.051435, -0.076200,
-0.329956, 0.034290, -0.038100,
-0.263965, 0.022860, -0.076200,
-0.263965, 0.028575, -0.152400
)
gol.draw_line_loop_3d(
-0.527929, 0.091440, -0.076200,
-0.593920, 0.114300, -0.038100,
-0.593920, 0.114300, 0.038100,
-0.527929, 0.091440, 0.076200,
-0.461938, 0.068580, 0.038100,
-0.461938, 0.068580, -0.038100
)
gol.draw_line_loop_3d(
-0.593920, 0.125730, 0.190500,
-0.593920, 0.137160, 0.266700,
-0.527929, 0.120015, 0.304800,
-0.461938, 0.091440, 0.266700,
-0.461938, 0.080010, 0.190500,
-0.527929, 0.097155, 0.152400
)
gol.draw_line_loop_3d(
-0.395947, 0.057150, 0.152400,
-0.329956, 0.045720, 0.190500,
-0.263965, 0.028575, 0.152400,
-0.263965, 0.022860, 0.076200,
-0.329956, 0.034290, 0.038100,
-0.395947, 0.051435, 0.076200
)
gol.draw_line_loop_3d(
-0.197973, 0.011430, -0.038100,
-0.197973, 0.011430, 0.038100,
-0.131982, 0.005715, 0.076200,
-0.065991, 0.000000, 0.038100,
-0.065991, 0.000000, -0.038100,
-0.131982, 0.005715, -0.076200
)
gol.draw_line_loop_3d(
0.131982, 0.005715, -0.076200,
0.131982, 0.011430, -0.152400,
0.065991, 0.011430, -0.190500,
-0.000000, 0.005715, -0.152400,
-0.000000, 0.000000, -0.076200,
0.065991, 0.000000, -0.038100
)
gol.draw_line_loop_3d(
0.329956, 0.045720, -0.190500,
0.329956, 0.057150, -0.266700,
0.263965, 0.051435, -0.304800,
0.197973, 0.034290, -0.266700,
0.197973, 0.022860, -0.190500,
0.263965, 0.028575, -0.152400
)
gol.draw_line_loop_3d(
0.527929, 0.137160, -0.381000,
0.461938, 0.125730, -0.419100,
0.395947, 0.097155, -0.381000,
0.395947, 0.080010, -0.304800,
0.461938, 0.091440, -0.266700,
0.527929, 0.120015, -0.304800
)
gol.draw_line_loop_3d(
-0.329956, 0.091440, 0.419100,
-0.263965, 0.068580, 0.381000,
-0.263965, 0.051435, 0.304800,
-0.329956, 0.057150, 0.266700,
-0.395947, 0.080010, 0.304800,
-0.395947, 0.097155, 0.381000
)
gol.draw_line_loop_3d(
-0.131982, 0.011430, 0.152400,
-0.197973, 0.022860, 0.190500,
-0.197973, 0.034290, 0.266700,
-0.131982, 0.034290, 0.304800,
-0.065991, 0.022860, 0.266700,
-0.065991, 0.011430, 0.190500
)
gol.draw_line_loop_3d(
0.065991, 0.011430, 0.190500,
0.131982, 0.011430, 0.152400,
0.131982, 0.005715, 0.076200,
0.065991, 0.000000, 0.038100,
-0.000000, 0.000000, 0.076200,
-0.000000, 0.005715, 0.152400
)
gol.draw_line_loop_3d(
0.197973, 0.011430, -0.038100,
0.197973, 0.011430, 0.038100,
0.263965, 0.022860, 0.076200,
0.329956, 0.034290, 0.038100,
0.329956, 0.034290, -0.038100,
0.263965, 0.022860, -0.076200
)
gol.draw_line_loop_3d(
0.461938, 0.068580, -0.038100,
0.527929, 0.091440, -0.076200,
0.527929, 0.097155, -0.152400,
0.461938, 0.080010, -0.190500,
0.395947, 0.057150, -0.152400,
0.395947, 0.051435, -0.076200
)
gol.draw_line_loop_3d(
-0.197973, 0.068580, 0.419100,
-0.197973, 0.091440, 0.495300,
-0.131982, 0.097155, 0.533400,
-0.065991, 0.080010, 0.495300,
-0.065991, 0.057150, 0.419100,
-0.131982, 0.051435, 0.381000
)
gol.draw_line_loop_3d(
-0.000000, 0.045720, 0.381000,
0.065991, 0.057150, 0.419100,
0.131982, 0.051435, 0.381000,
0.131982, 0.034290, 0.304800,
0.065991, 0.022860, 0.266700,
-0.000000, 0.028575, 0.304800
)
gol.draw_line_loop_3d(
0.329956, 0.057150, 0.266700,
0.329956, 0.045720, 0.190500,
0.263965, 0.028575, 0.152400,
0.197973, 0.022860, 0.190500,
0.197973, 0.034290, 0.266700,
0.263965, 0.051435, 0.304800
)
gol.draw_line_loop_3d(
0.527929, 0.091440, 0.076200,
0.461938, 0.068580, 0.038100,
0.395947, 0.051435, 0.076200,
0.395947, 0.057150, 0.152400,
0.461938, 0.080010, 0.190500,
0.527929, 0.097155, 0.152400
)
gol.draw_line_loop_3d(
0.065991, 0.137160, 0.647700,
0.131982, 0.125730, 0.609600,
0.131982, 0.097155, 0.533400,
0.065991, 0.080010, 0.495300,
-0.000000, 0.091440, 0.533400,
-0.000000, 0.120015, 0.609600
)
gol.draw_line_loop_3d(
0.197973, 0.068580, 0.419100,
0.197973, 0.091440, 0.495300,
0.263965, 0.114300, 0.533400,
0.329956, 0.114300, 0.495300,
0.329956, 0.091440, 0.419100,
0.263965, 0.068580, 0.381000
)
gol.draw_line_loop_3d(
0.461938, 0.125730, 0.419100,
0.527929, 0.137160, 0.381000,
0.527929, 0.120015, 0.304800,
0.461938, 0.091440, 0.266700,
0.395947, 0.080010, 0.304800,
0.395947, 0.097155, 0.381000
)
gol.draw_line_loop_3d(
-0.461938, 0.125730, -0.419100,
-0.527929, 0.137160, -0.381000,
-0.527929, 0.120015, -0.304800,
-0.461938, 0.091440, -0.266700,
-0.395947, 0.080010, -0.304800,
-0.395947, 0.097155, -0.381000
)
gol.draw_line_loop_3d(
-0.197973, 0.068580, -0.419100,
-0.197973, 0.091440, -0.495300,
-0.263965, 0.114300, -0.533400,
-0.329956, 0.114300, -0.495300,
-0.329956, 0.091440, -0.419100,
-0.263965, 0.068580, -0.381000
)
gol.draw_line_loop_3d(
-0.065991, 0.137160, -0.647700,
-0.131982, 0.125730, -0.609600,
-0.131982, 0.097155, -0.533400,
-0.065991, 0.080010, -0.495300,
0.000000, 0.091440, -0.533400,
0.000000, 0.120015, -0.609600
)
gol.draw_line_loop_3d(
0.593920, 0.125730, -0.190500,
0.593920, 0.137160, -0.266700,
0.527929, 0.120015, -0.304800,
0.461938, 0.091440, -0.266700,
0.461938, 0.080010, -0.190500,
0.527929, 0.097155, -0.152400
)
gol.draw_line_loop_3d(
0.527929, 0.091440, 0.076200,
0.593920, 0.114300, 0.038100,
0.593920, 0.114300, -0.038100,
0.527929, 0.091440, -0.076200,
0.461938, 0.068580, -0.038100,
0.461938, 0.068580, 0.038100
)
gol.draw_line_loop_3d(
0.593920, 0.137160, 0.266700,
0.593920, 0.125730, 0.190500,
0.527929, 0.097155, 0.152400,
0.461938, 0.080010, 0.190500,
0.461938, 0.091440, 0.266700,
0.527929, 0.120015, 0.304800
)
gol.draw_line_loop_3d(
-0.131982, 0.125730, 0.609600,
-0.065991, 0.137160, 0.647700,
0.000000, 0.120015, 0.609600,
0.000000, 0.091440, 0.533400,
-0.065991, 0.080010, 0.495300,
-0.131982, 0.097155, 0.533400
)
gol.draw_line_loop_3d(
-0.263965, 0.114300, 0.533400,
-0.197973, 0.091440, 0.495300,
-0.197973, 0.068580, 0.419100,
-0.263965, 0.068580, 0.381000,
-0.329956, 0.091440, 0.419100,
-0.329956, 0.114300, 0.495300
)
gol.draw_line_loop_3d(
-0.527929, 0.137160, 0.381000,
-0.461938, 0.125730, 0.419100,
-0.395947, 0.097155, 0.381000,
-0.395947, 0.080010, 0.304800,
-0.461938, 0.091440, 0.266700,
-0.527929, 0.120015, 0.304800
)

        
end
        