function meu:define_meu_infos()
	return { author = "Alain Longuet",
			   tags = { "2d", "art", "procedural", "vj", "unfinished" },
			   help = {
                        "Draw concentric circles with procedural size variation.",
                        "Position, scale, rotation, color, and line width are user adjustable.",
                        "This MEU is an experimental visual sketch."
                    }
		    }
end

function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
    local ix,iy = 1,1
    local SY,DY = 1,.2
    local bu


    
	bu = self:add_slider_xy(	{ix,iy,      8,5*SY},    "XY" )
        bu:set_value( .5, 1 )
        bu:set_value( .5, 2 )
        ui.bu_xy = bu   
    iy = iy + 5 * SY + DY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Scale",          self,   "scale",            1,          0,4   )
    iy = iy + SY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Ratio",          self,   "scale_y",          1,          0,4   )
    iy = iy + SY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Rotation",       self,   "rot_z",            0,          -1,1   )
    iy = iy + SY

    ix, iy = 9, 1
    
    bu = self:add_slider(       {ix,iy,         8,SY},    "Red",            self,   "color_red",        1,          0,1   )
        bu:set_meter_color_named( "red" )
    iy = iy + SY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Green",          self,   "color_green",      1,          0,1   )
        bu:set_meter_color_named( "green" )
    iy = iy + SY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Blue",           self,   "color_blue",       1,          0,1   )
        bu:set_meter_color_named( "blue" )
    iy = iy + SY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Alpha",          self,   "color_alpha",      1,          0,1   )
        bu:set_meter_color_named( "alpha" )
    iy = iy + SY + DY

    bu = self:add_slider(       {ix,iy,         8,SY},    "Line Width",     self,   "line_width",       1,          0,10  )
    iy = iy + SY + DY
end


    


function meu:update()
end
	


function meu:init_longuet_variables()  
    self.oxRect = -4
    self.oxPoint = 1
    self.oyPoint = 1
    self.oxDisk = 1
    self.oyDisk = 1 
    self.oxDisk2 = 1
    self.oyDisk2 = 1  
    self.sizeDisque1 = 1 self.siZeDisque2 = 1
    self.dOxDisk1 = .01 self.dOxDisk2 = .01
    self.oydT = {} self.oxdT = {} self.sizedT = {}
    self.nb=100
    for i=1,self.nb do
        self.oydT[i] = -1
        self.oxdT[i] = (math.random()-.5)
        self.sizedT[i] = 0.5
    end
end

function meu:init()
    self:init_longuet_variables()
end

function meu:draw()
    self:draw_layers_begin()
        --self:print( aaa.time.t )
        self:draw_layer( 1 )
        self:draw_35( self:get_alpha(), 5, false )       -- choose the drawing function here
    self:draw_layers_end()
end

-- documentation is in
--  AAADoc/lua_aaaseed_draw.lua
--  AAADoc/lua_aaaseed_interface.lua


-- CERCLES CONCENTRIQUES
function meu:draw_35( alpha )
    local sizeX = 14
    local bu = self.ui.bu_xy 
    local x,y = bu:get_value(1), bu:get_value(2)

    gol.color4( self.color_red, self.color_green, self.color_blue, self.color_alpha )
    gol.set_line_width( self.line_width )
    gol.set_line_smooth( true )

    gol.push_matrix()
        gol.translate( x, y )
        gol.rotate_z( self.rot_z )
        gol.scale(   self.scale   )
        gol.scale_y( self.scale_y )

        for i=1,self.nb do
            aaa.draw_circle_axe_z(  0,0 ,0,self.sizedT[i],256)
            --self.oydT[i] = self.oydT[i] + .04
            --self.oxDisk = self.oxDisk + self.dOxDisk1
            self.sizedT[i] = i*.2

            -- Mâa March 31st 2025 this have no effect
            if self.oydT[i]>4 then
                self.oydT[i] = -4*(math.random())-4
                self.oxdT[i] = sizeX*(math.random()-.5)
                --self.dOxDisk1 = (math.random()-.5)*0.01 
                self.sizedT[i] = math.random()*.5 + .1
            end
        end
    gol.pop_matrix ()
end
