function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
    local ix,iy = 1,1
    local SY,DY = 1,.2

    self:add_rendering()    --todo why we get remdering from layer_c ???
	self:add_camera()
    ix, iy = 9, 2 + DY
    self:add_transfo( {ix,iy,   8,2.4} )
    iy = iy + 2.4 + DY
end


function meu:init_longuet_variables()  
    self.oxRect = -4
    self.oxPoint = 1
    self.oyPoint = 1
    self.oxDisk = 1
    self.oyDisk = 1 
    self.oxDisk2 = 1
    self.oyDisk2 = 1  
    self.sizeDisque1 = 1 self.siZeDisque2 = 1
    self.dOxDisk1 = .01 self.dOxDisk2 = .01
    self.oydT = {} self.oxdT = {} self.sizedT = {}
    self.nb=100
    for i=1,self.nb do
        self.oydT[i] = -1
        self.oxdT[i] = (math.random()-.5)
        self.sizedT[i] = 0.5
    end
end

function meu:init()
    self:init_longuet_variables()
end

function meu:draw()
    self:draw_layers_begin()
        --  self:print( aaa.time.t )
        self:draw_layer( 1 )
        self:draw_33( self:get_alpha(), 5, false )       -- choose the drawing function here
    self:draw_layers_end()
end

-- documentation is in
--  AAADoc/lua_aaaseed_draw.lua
--  AAADoc/lua_aaaseed_interface.lua

-- Hello world
function meu:draw_1( alpha )
    gol.color_white( alpha )
    aaa.draw_str( "Bonjour\nil est "..os.date("%H:%M:%S") )
end


-- Flash
function meu:draw_2( alpha ) 
    gol.color_white( (math.sin(aaa.time.t * 10.) * .5 + .5) * alpha )
    aaa.draw_str( "Flash" )
end

-- Rectangle
function meu:draw_3( alpha )
    gol.color_green( alpha )
    aaa.draw_rect_line( -1,-1, 2,2 )
end

-- Points et diques proto Longuet
function meu:draw_31( alpha )
    gol.color_green( alpha )
    gol.set_point_size ( 100 )
    gol.draw_points_2d (0,0 )
    
    aaa.draw_disk_axe_z ( -1,1,0,1,36)
    gol.color_red( .4 )
    aaa.draw_disk_axe_z ( self.oxDisk,self.oyDisk,0,1,36)
    self.oxDisk = self.oxDisk + .01
    if self.oxDisk>3 then
       self.oxDisk = -2
    end   
end

-- Okiff proto 0 Longuet
function meu:draw_32( alpha )
    local sizeX = 14
    gol.color( 1,1,0,.4 )
    gol.set_line_width( 10 )
    aaa.draw_circle_axe_z ( self.oxDisk,self.oyDisk,0,self.sizeDisque1,36)
    self.oyDisk = self.oyDisk + .04
    self.oxDisk = self.oxDisk + self.dOxDisk1
    if self.oyDisk>4 then
        self.oyDisk = -4
        self.oxDisk = sizeX*(math.random()-.5)
        self.dOxDisk1 = (math.random()-.5)*0.01 
        self.sizeDisque1 = (math.random()-.5) + .1
    end  
    gol.color( 0,0,1,.4 )
    aaa.draw_circle_axe_z ( self.oxDisk2,self.oyDisk2,0,self.sizeDisque2,36)
    self.oyDisk2 = self.oyDisk2 + .04
    self.oxDisk2 = self.oxDisk2 + self.dOxDisk2
    if self.oyDisk2>4 then
        self.oyDisk2 = -4
        self.oxDisk2 = sizeX*(math.random()-.5)
        self.dOxDisk2 = (math.random()-.5)*0.01 
        self.sizeDisque2 = (math.random()-.5) + .1
    end    
end

-- Okiff proto 1 Longuet
function meu:draw_33( alpha )
    local sizeX = 14
    gol.color( 1,1,0,.4 )
    aaa.draw_disk_axe_z ( self.oxDisk,self.oyDisk,0,self.sizeDisque1,36)
    self.oyDisk = self.oyDisk + .04
    self.oxDisk = self.oxDisk + self.dOxDisk1
    if self.oyDisk>4 then
        self.oyDisk = -4
        self.oxDisk = sizeX*(math.random()-.5)
        self.dOxDisk1 = (math.random()-.5)*0.01 
        self.sizeDisque1 = (math.random()-.5) + .1
    end  
    gol.color( 0,0,1,.4 )
    aaa.draw_disk_axe_z ( self.oxDisk2,self.oyDisk2,0,self.sizeDisque2,36)
    self.oyDisk2 = self.oyDisk2 + .04
    self.oxDisk2 = self.oxDisk2 + self.dOxDisk2
    if self.oyDisk2>4 then
        self.oyDisk2 = -4
        self.oxDisk2 = sizeX*(math.random()-.5)
        self.dOxDisk2 = (math.random()-.5)*0.01 
        self.sizeDisque2 = (math.random()-.5) + .1
    end 
    gol.color( 1,0,0,.4 )
    for i=1,self.nb do
        aaa.draw_disk_axe_z ( self.oxdT[i],self.oydT[i],0,self.sizedT[i],36)
        self.oydT[i] = self.oydT[i] + .04
        --self.oxDisk = self.oxDisk + self.dOxDisk1
        if self.oydT[i]>4 then
            self.oydT[i] = -4*(math.random())-4
            self.oxdT[i] = sizeX*(math.random()-.5)
            --self.dOxDisk1 = (math.random()-.5)*0.01 
           self.sizedT[i] = math.random()*.5 + .1
           
        end
    end
end

-- Rectangles
function meu:draw_4( alpha, nb_factor )
    gol.color_yellow( alpha )
    local nb = 100 * nb_factor
    local size = 8
    local d = size/(nb-1)
    math.randomseed(42)
    for i=1,nb do
        local x = -size/2 + size * (i-1)/(nb-1)
        aaa.draw_rect_line( x,0, x+d,math.random()*2 )
    end
end

-- more Rectangles
function meu:draw_5( alpha, nb_factor )
    local nb_y = 8 * nb_factor
    local size_y = 8
    local d_y = size_y/(nb_y-1)

    local nb_x = 8 * nb_factor 
    local size_x = 8
    local d_x = size_x/(nb_x-1)
    math.randomseed(42)

    for iy=1,nb_y do
        local y = -size_y/2 + size_y * (iy-1)/(nb_y-1)
        for ix=1,nb_x do
            local x = -size_x/2 + size_x * (ix-1)/(nb_x-1)
            local rnd = math.random()
            --rnd = math.pow( rnd, 4 ) * 4.
            local d = rnd * d_y * .5
            d = d * (math.sin( -aaa.time.t * 5. + iy / 3. ) * .25 + .75 )
            local r,g,b = math.random(), math.random(), math.random()
            gol.color( r,g,b, alpha )  -- red green blue alpha
            --gol.color( r*rnd, g*rnd, b*rnd )
            aaa.draw_rect( x-d,y-d, x+d,y+d)
        end
    end
    
end

-- Some 3d
local function get_color()
    local r = math.random()
    local g = math.random()
    local b = math.random()
    local gam = 1.
    return math.pow(r,gam), math.pow(g,gam), math.pow(b,gam)
end

function meu:draw_6( alpha, nb_factor, b_rotate )
    local nb = 160 * nb_factor * nb_factor
    local size = 8
    math.randomseed(42)

    for i=1,nb do
        local x = size * (math.random() - .5)  
        local y = size * (math.random() - .5)  
        local z = size * math.random() * .1
        local r,g,b = get_color()
        gol.color( r,g,b, alpha )
         --gol.color( r*rnd,g*rnd,b*rnd )
        gol.push_matrix()
            gol.translate( x,y,z )
            if b_rotate then
                gol.rotate_y( math.random() )
                gol.rotate_x( math.random() )
            end
            local s = .5
            local sx = math.random() * s
            local sy = math.random() * s
            local sz = math.random() * s       
            aaa.draw_box( sx,sy,sz )
        gol.pop_matrix()
    end

end