
local function hook_switch_page( page_last, page_new )
	aaa.print( "intercept switch page from "..page_last.." to "..page_new )
	local page_www = { "http://blog.lecollagiste.com/article-mapping-monumental-de-telenoika-37451471.html",
						"http://blog.lecollagiste.com/article-mapping-monumental-de-telenoika-37451471.html",
						"http://blog.lecollagiste.com/article-mapping-monumental-de-telenoika-37451471.html",
						"http://blog.lecollagiste.com/article-mapping-monumental-de-telenoika-37451471.html",
						}
	if aaa.lua.global.get( "bu_www" ) then
		bu_www:set_www_page( page_www[page_new] )
	end
end
--bus_cur:set_fn_on_set_page( hook_switch_page )

function BU:click_kinect()
	local sx = self:get_sx()
	self:print( "sx is "..sx )
	if sx > 3 then
		self:cpy_orig_to_cur( "BU:click_kinect" )
	else
		for i,bu in IPAIRS( self.group ) do
			bu:cpy_orig_to_cur( "BU:click_kinect" )
		end
		self:set_window_state( "full", true )

		if self:is_video() then
			for i,bu in IPAIRS( self.group ) do
				bu:stop_video()
			end
			self:play_video()
		end
	end
end

local function compute_pos( nb )
	local col_nb, xl, xr, y, dx, dy, s
	xr = 3.5
	if nb == 1 then
		col_nb = 1
		xl = 0
		y = 0
		dx = 0
		dy = 0
		s = 2
	elseif nb <= 4 then
		col_nb = 2
		dx = 3
		dy = 2
		xl = -dx * .5
		y = dy * .5
		s =1.6
	else
		col_nb = 3
		dx = 2
		dy = 1.5
		xl = -dx
		y = dy
		s = .8
	end
	return col_nb, xl, xr, y, dx, dy, s
end

local function create_group_for_kinect( noms, flip )
	local group = {}

	local bu

	local nb = #noms
	local col_nb, xl, xr, y, dx, dy, s = compute_pos( nb )

	local x = xl
	for i=1,nb do
		--todo find video size
		bu = bus_cur:add_video( noms[i], {x,y, nil,s} )
		if bu then
			bu.group = group
			table.insert( group, bu )
			bu:set_texture_flip_u( flip )
			bu:set_mobile( false )
			bu:set_method_on_click( bu, "click_kinect" )
			x = x + dx
			if xr < x then
				x = xl
				y = y - dy
			end
		end
	end
end

local function maa_add_files( dir_name, b_image, b_video, b_button )
	aaa.print( "add_files(\""..dir_name.." )" )
	local t_file = aaa.dir.get_files( dir_name )
	if not t_file then
		aaa.print( "No Files there" )
		return 0
	end

	local group = {}

	local nb_tot = #t_file
	local col_nb, xl, xr, y, dx, dy, s = compute_pos( nb_tot )

	local x = xl

	local nb = 0
	for i,name in pairs( t_file ) do
		local bu
		aaa.print_debug( "file : "..i.." .. "..name )
		local filename = dir_name.."/"..name
		aaa.print_debug( "filename : "..filename )
		if MEDIA.is_name_image( name ) then
			if b_image then
				aaa.print_debug( "image "..filename )
				nb = nb + 1
				bu = bus_cur:add_image( "Image_"..i, {x,y, nil, s}, filename, true )
			end
		elseif MEDIA.is_name_video( name ) then
			if b_video then
				aaa.print_debug( "video "..filename )
				VIDEOS:set_movie_dir( dir_name.."/" )
				bu = bus_cur:add_video( name, {x,y, nil,s} )
				if bu then
					nb = nb + 1
					bu:set_video_button(true)
				end
			end
		else
			aaa.print_debug( "add_files() not recognized : "..filename )
		end
		nb_tot = nb_tot - 1
		if bu then
			bu.group = group
			table.insert( group, bu )
			--bu:set_texture_flip_u( flip )
			bu:set_mobile( false )
			bu:set_method_on_click( bu, "click_kinect" )

			x = x + dx
			if xr < x then
				x = xl
				y = y - dy
				if y <= -2 then
					bus_cur:add_button_refresh()
					if nb_tot > 0 then
						bus_cur:inc_page()
						col_nb, xl, xr, y, dx, dy, s = compute_pos( nb_tot )
					end
				end
			end
		end
	end
--[[
	if nb > 0 then
		self:print_debug( "added "..nb.." bu" )
		if b_button then self:add_page_buttons() end
		self:inc_page()
	end
--]]
	return nb
end

if aaa.lua.global.declare( "maa_show_pages_define" ) then
	function maa_show_pages_define( b_kinect )
		local ratio_x = 1.77
		local taille_x = 3 * ratio_x;
		local taille_y = 3;
		local bu
		local noms

		local make_domino = b_kinect and create_group_for_kinect or DOMINO.create
		local bus = BUS:create( "AAAMaa" )
		bus:init_begin_add_to_ga()
		bus:set_bu_pos_load_save( not b_kinect )

			--START
			-- with www
			bu_www = bus:add_www( 0, 0, 4. )

			bus:inc_page()

			VIDEOS:set_dir_media( "Maashow" )

			local maa_dir		=	"01_Maa/"
			local mucho_dir		=	"10_Mucho/"
			local mucho_older	=	"11_MuchoOlder/"
			local main_boucle	=	"Planets.avi"

			--	PAGE_1	BOUCLE
			--bus:add_boucle( main_boucle )
			--bus:inc_page()

			--	PAGE_8  Maa
			local bui = bus:get_bu_nb()
			noms = { 	maa_dir.."Epidemik.avi",
						maa_dir.."Human tracking.AVI",
						maa_dir.."Scenario_Futur.avi",
						maa_dir.."Achi2005_CeQuiNousRegarde.avi",
						maa_dir.."Cleaning.avi",
						maa_dir.."bouyges.AVI",
						}
			make_domino( noms, false )

			bus:add_button_refresh()
			bus:inc_page()

			--	PAGE_  Floating Point
			bui = bus:get_bu_nb()
			noms = { 	maa_dir.."Upstream_mp4.avi",
						maa_dir.."AAA_Floating_point_scopitone_by_Maa.AVI",
						maa_dir.."FloatingPoint_ca_se_danse.AVI",
						maa_dir.."AAAFluxFlurieux_Lyon_h263.avi",
					}
			make_domino( noms, false )
			bus:add_button_refresh()
			bus:inc_page()

			--	PAGE_  Multitouch
			bui = bus:get_bu_nb()
			noms = { 	maa_dir.."Table_France_5_Montage.avi",
						maa_dir.."Atlas_1.mp4",
						mucho_older.."lolopmucho3.mp4",
						mucho_older.."Touch_Brush.avi",
						--mucho_dir.."Touch_laser.avi",
					}
			make_domino( noms, false )

			--bus:inc_page()
			--maa_add_files( app.media_dir_rel.."utram_garden/monumentale/", true, true, false )

			bus:add_button_refresh()

		--[[
			VIDEOS:set_dir_media( "CreartBox/Y_Movie/Sea" )
			noms = { 	"Deep_Water_01.avi",
						"Deep Water_02.avi",
						"Deep Water_03.avi",
						"Shallow.Seas_02.avi",
						--"Mucho/Touch_laser.avi",
					}
			make_domino( noms, false )
			bus:inc_page()


			VIDEOS:set_dir_media( "CreartBox/Y_Movie/Video_HD" )
			--	PAGE_11 BOUCLE
			bus:add_boucle( main_boucle )
			bus:inc_page()

			--PAGE_WWW
			--Pages_www_add()
			--bus:inc_page()

			--	PAGE_12  FOTOMATON
			--Aaart_add()

			bus:make_bus_loop()
		--]]
			--the scrolling bu is on the bottom
			bus:add_scroll( -4, b_kinect and 4 or 0 )

		bus:init_end()

		bus:set_fn_on_set_page( hook_switch_page )

		--	local wel = aaa.lua.global.get( "AAAWelcome" )
		--if wel then
		--	wel.page_active = { 0,2,6,7 }
		--end

		return bus
	end
end

if aaa.lua.global.declare( "maa_bus_dir_define" ) then
	function maa_bus_dir_define( dir, b_kinect )

		local ratio_x = 1.77
		local taille_x = 3 * ratio_x;
		local taille_y = 3;
		local bu
		local noms

		local bus = BUS:create( "MaaDir" )
		bus:init_begin_add_to_ga()
		bus:set_bu_pos_load_save( not b_kinect )

			--START
			-- with www
		--	bu = bus:add_www( 0, 0, 4. )

		--	bus:inc_page()
			local full_dir = APP.media_dir_rel..dir

			maa_add_files( full_dir, true, true, false )

			bus:add_button_refresh()

			--the scrolling bu is on the bottom
			if bus:get_page_nb() > 1 then
				bus:add_scroll( -4, b_kinect and 4 or 0 )
			end

		bus:init_end()

		bus:set_fn_on_set_page( hook_switch_page )

		--	local wel = aaa.lua.global.get( "AAAWelcome" )
		--if wel then
		--	wel.page_active = { 0,2,6,7 }
		--end

		return bus
	end
end

if IS_BUSS_OPEN() then --was    and not m42 then
	--GABUIN.set( "dirty", false, false, false, 1 )
	GABUIN.set( nil, false, false, false, 32 )
	--maa_show_pages_define( false )
	maa_bus_dir_define( "MaaShow/Pierre/" )
end
