if aaa.lua.global.declare( "m42" ) then
	--todo create class APP_M42 class
	--2021 Maa updated
	m42 = APP.CREATE_INST( APP, "m42" )
	--m42 = APP:create( "m42" )
end

--	could be useful
function m42:set_frustum()
	local ref = self.ref
	param.set( ref.camera_frustrum_x, 0 )
	param.set( ref.camera_frustrum_y, 0 )
end

function m42:init_app()
	--todo removed when m42 solved
	--self:box_debug( "m42:init_app()" )

	if self:is_init_done() then return end

	self.location = {}
	local loc = self.location
	if aaa.pc.is_maa() then
		loc.name = "home"
	elseif aaa.net.machine == "SMARTV_B" then
		loc.name = "bear"
	elseif aaa.net.machine == "SMARTV_C" then
		loc.name = "in104"
	end

	loc.comp_y_center = 1.2
	loc.comp_y_factor = .3

	if loc.name == "peniche" then
		loc.motor_pos = .12
--	CONFIG HOME au dessus ecran
		loc.kinect_rot = -.030
		loc.skew = -.643

		loc.min_x = -2.
		loc.max_x = 2.
		loc.min_y = -10
		loc.min_z = -10

		loc.comp_y_center = .7
		loc.comp_y_factor = .3

		loc.click	 = .932
		loc.off		 = .851
		loc.far		 = .727

		loc.y_offset = 0
		loc.xy_scale = 8
	elseif loc.name == "home" then
		if false then
--	CONFIG HOME au dessus ecran
			loc.kinect_rot = -.091
			loc.skew = -.633

			loc.min_x = -2.
			loc.max_x = 2.
			loc.min_y = -10
			loc.min_z = -10

			loc.comp_y_center = .7
			loc.comp_y_factor = .3

			loc.click	 = .77
			loc.off		 = .60
			loc.far		 = .49

			loc.y_offset = 0
			loc.xy_scale = 6
		else
--	CONFIG HOME other
			loc.kinect_rot = .069
			loc.skew = -.633

			loc.min_x = -2.
			loc.max_x = 2.
			loc.min_y = -10
			loc.min_z = -10

			loc.comp_y_center = .7
			loc.comp_y_factor = .3

			loc.click	 = .77
			loc.off		 = .60
			loc.far		 = .49

			loc.y_offset = 0
			loc.xy_scale = 6
		end
	elseif loc.name == "bear" then
--	CONFIG vitrine passage
		loc.motor_pos = .915033

		loc.kinect_rot = .094
		loc.skew = .377

		loc.min_x = -.6
		loc.max_x = .6
		loc.min_y = .125
		loc.min_z = .125

		loc.comp_y_center = -.7
		loc.comp_y_factor = .3

		loc.click	 = .958
		loc.off		 = .768
		loc.far		 = .552

		loc.y_offset = 0
		loc.xy_scale = 16
	elseif loc.name == "in104" then
--	CONFIG au 104
		loc.motor_pos = .947

		loc.kinect_rot = .069
		loc.skew = .567

		loc.min_x = -2.
		loc.max_x = 2.
		loc.min_y = -10
		loc.min_z = -10

		loc.comp_y_center = -.7
		loc.comp_y_factor = .3

		loc.click	 = .77
		loc.off		 = .60
		loc.far		 = .49

		loc.y_offset = 1.61
		loc.xy_scale = 9.64
	else
		loc.motor_pos = .915033

		loc.kinect_rot = .069
		loc.skew = .436741

		loc.min_x = -.6
		loc.max_x = .6
		loc.min_y = .125
		loc.min_z = .125

		loc.comp_y_center = -.7
		loc.comp_y_factor = .3

		loc.click	 = .77
		loc.off		 = .60
		loc.far		 = .49

		loc.y_offset = 0
		loc.xy_scale = 6
	end
	self:set_master( true )

--[[
	if not self:is_master() then
		aaa.flatland.set_draw( false )
		aaa.set_lua_silent()
	end
	param.set( aaa.ref.app, "quit_do_save", self:is_master() )
--]]

	local ref = self.ref

	--PARTICLE
	local prefix = self:get_prefix().."part_"
	ref.part_layers			=	aaa.obj.get( prefix.."layers" )
	ref.part_grad_layer		=	aaa.obj.get( prefix.."grad_layer" )
	ref.part_halo_layer		=	aaa.obj.get( prefix.."halo_layer" )
	ref.part_halo_bdd		=	aaa.obj.get( prefix.."halo_bdd" )
		ref.part_halo_nb_by_sec	=	param.get_ref(  ref.part_halo_bdd, "nb_by_sec" )
	ref.part_layer			=	aaa.obj.get( prefix.."layer" )
	ref.part_bdd			=	aaa.obj.get( prefix.."bdd" )
		ref.part_nb_by_sec		=	param.get_ref(  ref.part_bdd, "nb_by_sec" )
	ref.part_trs			=	aaa.obj.get( prefix.."trs" )
		ref.part_x				=	param.get_ref(  ref.part_trs, "translate_x" )
		ref.part_y				=	param.get_ref(  ref.part_trs, "translate_y" )
		ref.part_z				=	param.get_ref(  ref.part_trs, "translate_z" )
		ref.part_sx				=	param.get_ref(  ref.part_trs, "scale_x" )
		ref.part_sy				=	param.get_ref(  ref.part_trs, "scale_y" )
		ref.part_sz				=	param.get_ref(  ref.part_trs, "scale_z" )
		ref.part_sf				=	param.get_ref(  ref.part_trs, "scale_factor" )

	--BACKDROP
	ref.backdrop = {}
	ref.backdrop[1]	=	aaa.obj.get( "backdrop_cubes" )
	ref.backdrop[2]	=	aaa.obj.get( "backdrop_rain" )

	prefix = self:get_prefix()
	--FOREGROUND
	ref.foreground_layers	=	aaa.obj.get( prefix.."foreground_layers" )

	--GRILLE
	ref.grille_layers		=	aaa.obj.get( prefix.."grille_layers" )

	--FBO
	self.fbo_and_out = FBO_AND_OUT:create( self:get_name(), 0 )

	--CAMERA
	ref.camera_layers		=	aaa.obj.get( prefix.."camera_layers" )
	ref.camera				=	aaa.obj.get( prefix.."camera" )
		ref.camera_tra_z		=	param.get_ref( ref.camera, "tra_z" )
		ref.camera_frustrum_x	=	param.get_ref(  ref.camera, "frustum_offset_x" )
		ref.camera_frustrum_y	=	param.get_ref(  ref.camera, "frustum_offset_y" )

	--kinect and skel
	local module = aaa.module.get_cur()
	if aaa.lua.global.get( "SKEL" ) then
		self.skel = SKEL:create( module, aaa.obj.get_branch_by_name_symbo( module, "kinect" ) )
		self.skel:set_top_to_track()
	else
		self:box_error( "no SKEL obj ready, clean this code please (maa July 2015)" )
	end

	self:init_scope()
	self:init_osc()

	if aaa.lua.global.get( "SKUI_ARROW" ) then
		self.arrow = SKUI_ARROW:create( "dum", self.skel )
		local arrow = self.arrow
		arrow:set_base( "neck", .25, -.8 )
		arrow:set_but_method( self, "do_arrow" )
	else
		self:box_error( "no SKUI_ARROW obj ready, clean this code please (maa July 2015)" )
	end

	self.bodys = BODYS:create( "all" )
	self.bodys:add( "Base",		4	)
	self.bodys:add( "Honda",	14	)
	self.bodys:add( "Conserve",	14	)
	self.bodys:add( "Picasso",	14	)
	self.bodys:add( "LeSaint",	14	)

	--CREATE all the wspace
	self.spaces = {}
	local spaces = self.spaces
	spaces.base			= WSPACE:create( "base", aaa.module.get_cur() )

	if false then
		spaces.village_innov 	= WSPACE:create( "village_innov", 	aaa.module.get_cur() )
		spaces.village_innov.b_corner = true
		spaces.village_innov.NB_X = 0
		spaces.village_innov.NB_Z = 0

		spaces.training 		= WSPACE:create( "training",		aaa.module.get_cur() )
		spaces.training_bis 	= WSPACE:create( "training_bis",	aaa.module.get_cur() )

		spaces.bear	= SPACE_BEAR:create( "Bear" )

		if maa_show_pages_define then
			spaces.maa	= SPACE:create( "Maa" )

			--spaces.maa:set_bus( maa_show_pages_define( true ) )
			spaces.maa:add_bus_creator( function() return maa_show_pages_define( true ) end )

			local tab = { "corporate", "labs", "live", "monumental", "museo", "salons", "sports", "television", "vente" }
			--local tab = { "corporate" }
			for i,name in ipairs( tab ) do
				spaces[name] = SPACE:create( name )
				--spaces[name]:set_bus( maa_bus_dir_define( name, true ) )
				spaces[name]:add_bus_creator( function() return maa_bus_dir_define( name, true ) end )
			end
		end
	end
--]]
	--self.spaces.nowhere = SPACE:create( "NowWhere" )
	--then build building from root
	for k,space in pairs( spaces ) do
		space:init_buildings()
	end

	self.space_stack = STACK:create( "m42" )
	self.space_stack:set_size_min( 1 )
	self.space_stack:push( self.spaces.base )

--[[
	local b_master = self:is_master()
	param.set( "m42_boid", "net_received", 		not b_master )
	param.set( "m42_boid", "net_send", 			b_master )
	param.set( "m42_capture_layers", "active",	b_master )
	param.set( ref.part_bdd, "net_received",	not b_master )
	param.set( ref.part_bdd, "net_send", 		b_master )
	param.set( ref.part_halo_bdd, "net_received",	not b_master )
	param.set( ref.part_halo_bdd, "net_send", 		b_master )
--]]
--[[
	MEDIA.set_dir_media( "Matrix42/Map_cube" )
	local noms =	{
					"deroule_allocine",
					"deroule_bfm",
					"deroule_facebook",
					"deroule_gulli",
					"deroule_orange",
					"deroule_pagesjaunes",
					"deroule_skype",
					"deroule_smartreplay",
					"deroule_tf1",
					"deroule_videofutur",
					}
	for i=1, #noms do
		IMGS.get_bind( noms[i]..".png" )
	end
--]]
--[[
	self.video = VIDEOS:get( app.media_dir_rel.."SmarTv/smart_TV_HD_Maa.avi" )
	--self.video:set_loop( true )
	self.video:play()
--]]
	self:set_init_done()
end

