
if not m42.wspace_def then
	m42.wspace_def = {}
end

BUILDING_DEF.put_table
{
	{	name ="center",
		type = "wspace",
		space_name = "training",
	},
	{	name="center_bis",
		type = "wspace",
		space_name = "training_bis",
	},
	{	name="center_3",
		type = "wspace",
		space_name = "training_bis",
	},
}

m42.wspace_def.training =
{
	{	b_def="center",
		sx=1, sz=3, sy=5, x=-1.5, z=-2,
	},
	{	b_def="center_bis",
		sx=1, sz=10, sy=5, x=1.5, z=-2,
	},
	{	b_def="center_3",
		sx=1, sz=1, sy=5, x=0, z=2,
	},
}

m42.wspace_def.training_bis =
{
	{	b_def="center",
		sx=1, sz=3, sy=5, x=-1.5, z=-2,
	},
	{	b_def="center_bis",
		sx=1, sz=10, sy=5, x=1.5, z=-2,
	},
	{	b_def="center_3",
		sx=1, sz=1, sy=5, x=0, z=-2,
	},
	{	b_def="center",
		sx=1, sz=30, sy=5, x=-1.5, z=2,
	},
	{	b_def="center_bis",
		sx=1, sz=10, sy=5, x=1.5, z=2,
	},
	{	b_def="center_3",
		sx=1, sz=1, sy=50, x=0, z=2,
	},
}

local dir = aaa.dir.get_dir_media()
BUILDING_DEF.put_table
{
	{	name = "corporate",
		url = "file:///"..dir.."Utram2012/web_copy/utram.fr.htm",
		directory = app.media_dir_rel.."Utram2012/images_selected/corporate",
		space_name = "corporate",
	},
	{	name = "labs",
		--url = "http://www.utram.com/fr/utram-labs/utram-labs/",
		url = "file:///"..dir.."Utram2012/web_copy/utramlab.fr.htm",
		directory = app.media_dir_rel.."Utram2012/images_selected/labs",
		space_name = "labs",
	},

	{	name = "live",
		url = "file:///"..dir.."Utram2012/building_localtextures/live1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/live",
		space_name = "live",
		geo = "cone",
	},

	{	name = "monumental",
		url = "file:///"..dir.."Utram2012/building_localtextures/monu1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/monumental",
		space_name = "monumental",
		geo = "cone",
	},
	{	name = "museo",
		url = "file:///"..dir.."Utram2012/building_localtextures/musee1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/museo",
		space_name = "museo",
		geo = "cone",
	},
	{	name = "salons",
		url = "file:///"..dir.."Utram2012/building_localtextures/salon1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/salons",
		space_name = "salons",
	},
	{	name = "sports",
		url = "file:///"..dir.."Utram2012/building_localtextures/sport1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/sports",
		space_name = "sports",
	},
	{	name = "television",
		url = "file:///"..dir.."Utram2012/building_localtextures/tv1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/television",
		space_name = "television",
	},
	{	name = "vente",
		url = "file:///"..dir.."Utram2012/building_localtextures/vente1.jpg",
		directory = app.media_dir_rel.."Utram2012/images_selected/vente",
		space_name = "vente",
		geo = "cone",
	},

	{	name = "FloatingPoint",
		--url = "www.youtube.com",
		url="www.astropolis.org/2011/cache/com_zoo/images/vlcsnap-2010-03-23-20h41m47s0_395ac0656d7a7adad8a8862ecba78922.png",
		--on_enter = "floatingpoint",
		geo = "cone",
		space_name = "maa",
	},

	{	name = "Pong",
		url = "file:///"..dir.."utram/building_localtextures/pong01.png",
		--on_enter = "pong",
		type = "pong",
		geo = "cone",
		space_class = "PONG"
	},

	{	name = "training",
		url = "file:///"..dir.."utram/building_localtextures/psyche.jpg",
		--on_enter = "training",
		type = "wspace",
		space_name = "training",
		geo = "cone",
	}
}

if m42.spaces then
	local space = m42.spaces.base
	space.space_factor = 1.
	space.building_factor = .7
	space.title_factor = 1.
end

m42.wspace_def.base =
{
	{	title = "Corporate", b_def = "corporate",
		sx=1, sz=3, sy=5, x=-1.5, z=-2,
	},
	{	title = "Labs", b_def = "labs",
		sx=1, sz=3, sy=6, x=1.5, z=1.5,
	},
	{	title = "Live", b_def = "live",
		sx=2, sz=2, sy=5, x=3, z=0,
	},
	{	title = "Monumental", b_def = "monumental",
		sx=2, sz=2, sy=6, x=3, z=3,
	},
	{	title = "Museo", b_def = "museo",
		sx=2, sz=2, sy=5, x=-2, z=3,
	},
	{	b_def = "salons",
		sx=2, sz=2, sy=3, x=2, z=4,
	},
	{	b_def = "sports",
		sx=1, sz=1, sy=5, x=.5, z=2.5,
	},
	{	b_def = "television",
		sx=2, sz=1, sy=7, x=1, z=3.5,
	},
	{	b_def = "vente",
		sx=1, sz=1, sy=9, x=2, z=5.5,
	},

	{	b_def = "FloatingPoint", b_active = true,
		sx=1, sz=1, sy=5, x=2.5, z=2.,
	},

	{	b_def = "Pong",
		sx=1, sz=1, sy=3, x=-.5, z=3.5,
	},

	{	b_def = "training", b_active = true,
		sx=1, sz=1, sy=8, x=-.5, z=-3.5, rot = .125
	}
}

