
if not aaa.lua.global.get( "ota" ) then
	--2021 Maa updated
	aaa.lua.global.set( "ota",  APP.CREATE_INST( APP, "ota" ) )
	--aaa.lua.global.set( "ota", APP:create( "ota" ) )
	--m42.time_aaaseed_start = aaa.time.t
end
-- we removed
--local app = ota
-- os it ok ?

--	le sas fait 15 sur 5 carreaux de 60cm plus 17.5 cm a gauche et 15 cm a droite
--		donc 932..5 cm x 300 cm

--	NET
--		Mac address de la Machine OT ds le plafond
local mac_addr = "54-04-a6-48-8d-35"

--
--	FX_OTAIX
--
CLASS.DECLARE( "FX_OTAIX", FX )

function FX_OTAIX:read_def( filename )
	--self:print( "toto" )
	self.def = {}
	self.b_loaded = app:dofile( filename, self.def )
	return self.b_loaded
end

function FX_OTAIX:load_from_def()
	local app_def = app.def

	local b_ret = self:read_def( app_def.config_filename )
	if b_ret then
		MEDIA.set_dir( app_def.dir_name )

		local def = self.def
		app:set_fond( def.fond )

		local nb = 0
		if def.images then
			for i,v in ipairs( def.images ) do
				local bind = IMGS.get_bind( v )
				if bind then
					nb = nb + 1
					if nb == 1 then	self.bind = bind end
				end
			end
		end
		self.bind = self.bind or 0
		aaa.print( "loaded "..nb.." images" )
		self.nb_tex = nb

		self.pal_bind = def.palette and IMGS.get_bind( def.palette ) or 0
	end
	return b_ret
end

function FX_OTAIX:create( obj, name, b_active )
	local self = FX_OTAIX:create_instance_with_obj( name, obj )
	self:init_inst( b_active )
	return self
end

--	could be useful
function ota:set_frustum()
	local ref = self.ref
	param.set( ref.camera_frustrum_x, 0 )
	param.set( ref.camera_frustrum_y, 0 )
end

function ota:reset_fbo_grid()
	local fbo_and_out = self.fbo_and_out
	local D = 6.
	local S = 5.9
	for i=1,3 do	fbo_and_out:set_xy( i, (i-2)*D, 0 )	end
	fbo_and_out:set_size_uv( S, S*5/8 )
	--fbo_and_out:reset_grid()
	--fbo_and_out:set_grid_nb_uv( 11, 8 )
end

function ota:set_fx_min_max( min, max )
	local ref = self.ref
	param.set( ref.size_min,		min )
	param.set( ref.size_max,		max )
	param.set( ref.size_min_insect,	min )
	param.set( ref.size_max_insect,	max )
end
function ota:init_fx_min_max()
	local ref = self.ref

	ref.size_min		= param.get_ref( "ota_draw_one_trax_size",		"limit_min" )
	ref.size_max		= param.get_ref( "ota_draw_one_trax_size",		"limit_max" )

	ref.size_min_insect	= param.get_ref( "ota_draw_insect_trax_size",	"limit_min" )
	ref.size_max_insect	= param.get_ref( "ota_draw_insect_trax_size",	"limit_max" )
end

function ota:make_fxs()
	--FX1
	self.fxs = FXS:create( self:get_name() )

	self:init_fx_min_max()

	local fx
	--GRILLE
	fx = self.fxs:add_obj( self:get_prefix().."grille_layers", 		"Grille",		true )

	self.def = {}
	self.config_filename = app.media_dir_rel.."OTAix/otaix_config.lua"
	self.b_loaded = self:dofile( self.config_filename, self.def )
	self.config_mdate = aaa.file.get_modification_date( self.config_filename )

	if self.b_loaded then
		local def = self.def
		local anim = def.animation
		def.dir_name = app.media_dir_rel.."OTAix/"..def.animation.."/"..def.nom.."/"
		def.config_filename = def.dir_name..anim..".lua"

		local obj = aaa.obj.get_no_error( self:get_prefix()..anim )
		if obj then
			local fx = FX_OTAIX:create( aaa.obj.get_no_error(self:get_prefix()..anim), anim, true )
			if fx.b_loaded then
				self.fxs:add_fx( fx )
				self:add_log( "animation charge : "..anim )
			end
		else
			self:add_log_error( "Cette animation n'existe pas : "..anim )
		end
	end

	--FOREGROUND
	fx = self.fxs:add_obj( self:get_prefix().."foreground_layers", 	"Foreground",	true )
end

function ota:set_fond( filename )
	local ref = self.ref
	ref.fond_layer = nil
	local bind = nil
	if filename then
		bind = IMGS.get_bind( filename )
	end
	self.fond_bind = bind
	if bind then
		ref.fond_layer = aaa.obj.get_branch_by_name_symbo( aaa.module.get_cur(), "fond" )
		aaa.layer.set_bind_2d( ref.fond_layer, bind )
	end
end

function ota:draw_fond()
	local ref = self.ref
	if ref.fond_layer then
		aaa.obj.update_then_draw( ref.fond_layer )
	end
end

function ota:init()
	if self:is_init_done() then return end

	self:create_log_in_dir( app.media_dir_rel.."OTAix/", 3600 )
	self:set_master( true )

	if self:is_onsite() then
		aaa.flatland.set_focus_offset( 301, 32 )
		param.set(	aaa.ref.pref,	"clean_render",	false	)
		ga:set_fullscreen()
		self:set_shutdown_no_save_on_time( 00, 2 )
	end
	ga:set_lock_app( self:is_onsite() )

--[[
	if not self:is_master() then
		aaa.flatland.set_draw( false )
		aaa.set_lua_silent()
	end
	param.set( aaa.ref.app, "quit_do_save", self:is_master() )
--]]
	param.set( aaa.ref.pref, "keyboard_country", aaa.pc.is_maa() and "UK" or "France" )

	local ref = self.ref
	local prefix = self:get_prefix()
	--	CAM
	self.cam_in			=	FX:create(	"Cam",			aaa.obj.get_no_error( prefix.."cam_in" ), 		true	)
	self.cam_edit		=	FX:create(	"Cam Edit", 	aaa.obj.get_no_error( prefix.."cam_edit" ), 	true	)
	self.cam_draw		=	FX:create(	"Cam Draw",		aaa.obj.get_no_error( prefix.."cam_draw" ), 	true	)
	self.cam_process	=	FX:create(	"Cam Process",	aaa.obj.get_no_error( prefix.."cam_process" ),	true	)

	--	FBO
	self.fbo_and_out = FBO_AND_OUT:create( self:get_name(), 3 )
	local sx, sy = 16, 5
	if self:is_onsite() then
		sx =	sx * 2.
		sy =	sy * 2.
	else
		sx =	sx * .5
		sy = 	sy * .5
	end
	self.fbo_and_out:set_pixel_size( 240 * sx, 240 * sy )
	self:reset_fbo_grid()

	--	FXS
	self:make_fxs()

	--	CAMERA
	ref.camera_layers		=	aaa.obj.get( prefix.."camera_layers" )
	ref.camera				=	aaa.obj.get( prefix.."camera" )
	ref.camera_tra_z			=	param.get_ref( ref.camera, "tra_z" )
	ref.camera_frustrum_x		=	param.get_ref(  ref.camera, "frustum_offset_x" )
	ref.camera_frustrum_y		=	param.get_ref(  ref.camera, "frustum_offset_y" )

	aaa.net.send_magic_packet( 0, mac_addr )

	--todo perhaps reinsatate waiting mecamnism because of window boot but this time inside the capture script
	self:set_init_done()
end
