
function ota:draw()
	local ref = self.ref

	--CAMERA
	local cam_in = self.cam_in
	if not cam_in then	--not initialized yet it seems Maa 2024 Sep
		return
	end

	cam_in:draw()
	self.cam_draw:draw()
	self.cam_process:draw()
	--	FBO
	if self.b_fbo then
		self.fbo_and_out:draw_fbo()
	end
	--	CAMERA
	aaa.obj.update_then_draw( ref.camera_layers )
	--	FOND
	if self.b_fond then
		self:draw_fond()
	end
	--	FXS
	self.fxs:updraw()
	self.cam_edit:draw()

	--	FBO_OUT
	if self.b_fbo then
		if self.b_fbo_out then
			self.fbo_and_out:draw_out()
		else
			self.fbo_and_out:draw_visu()
		end
	end
end

function ota:update()
	if not self:is_init_done() then return end
	-- previous line not enough
	if not self.config_filename then return end
	APP.update( self )


	--self:print( self.config_mdate.." "..aaa.file.get_modification_date( self.config_filename ) )
	if self.config_mdate ~= aaa.file.get_modification_date( self.config_filename ) then
		self:print( "change if config file trigger reload" )
		GABU.load( true )
	end

	local S = 60.
	local L = 17
	local R = 16
	local W = 1 / 16.
	self.fbo_and_out:set_u_one(	1, -1 * W, 	7  * W	)
	self.fbo_and_out:set_u_one( 2,  4 * W,	12 * W	)
	self.fbo_and_out:set_u_one( 3,  9 * W,	17 * W	)
	local gamma = self.b_gamma and self.ui.bu_gamma:get_value() or 0.
	self.fbo_and_out:set_gamma_fuzzy( gamma )

	self.time = aaa.time.t

	if self:is_onsite() and not aaa.is_edit() then
		ga:force_fullscreen()
	end

--[[
	if not self.net_started and aaa.time.t > (self.time_aaaseed_start + 16.) then
		aaa.net.set_active( true )
		self.net_started = true
	end
--]]
	--self.set_frustum()

	self:draw()
end



if IS_BUSS_OPEN() then
	ota:clear_init_done()
	ota:init()
	ota:define_app_ui()
else
	ota:update()
end



