if not FX.cur then
	aaa.layers.skip_rest()
	return
end
local fx = FX.cur

function fx:load()
	if self:load_from_def() then
		local def = self.def
		local ref = self.ref

		local bind = app.fond_bind
		if bind then
			aaa.layer.set_bind_2d( ref.layer_b, bind )
		end

		if def.deformation_influence	then	self.shading:set_frag_float( 1, def.deformation_influence )	end
		if def.color_influence			then	self.shading:set_frag_float( 2, def.color_influence )		end
		if def.seuil					then	param.set( ref.bdd_water, "image_threshold", def.seuil )	end
		if def.attenuation				then	param.set( ref.bdd_water, "damping", def.attenuation )		end
--[[
		param.set( self.ref.tex_anim, "start",	self.bind )
		param.set( self.ref.tex_anim, "stop",	self.bind + self.nb_tex-1 )

		param.set( ref.bdd_part, "nb_by_sec", def.nombre_par_sec and def.nombre_par_sec or 15 )
		param.set( ref.bdd_part, "life_time", def.duree_sec and def.duree_sec or 4. )

		app:set_fx_min_max( def.taille_min_cm and def.taille_min_cm or 2., def.taille_max_cm and def.taille_max_cm or 10. )
--]]
	end
end

function fx:init()
	local ref = self.ref

	ref.bdd_water	=	aaa.obj.get_branch_by_class( ref.layer_a, "bdd_img_water" )
	ref.layer_b		=	aaa.layers.get_layer( ref.obj, 2 )
	self.shading	=	aaa.layer.create_shading( ref.layer_b, "layer_b" )

--	ref.tex_anim = aaa.obj.get_branch_by_class( ref.layer_a, "tex_anim" )
--	ref.bdd_part = aaa.obj.get_branch_by_class( ref.layer_a, "bdd_particle" )

	self:load()
end

function fx:draw_low()
	--if math.random() < aaa.time.dt then
	--	self:flip_elt( math.random( 3, self.nb_u -2 ), math.random( 1, self.nb_v ) )
	--end
--	gol.push_attrib())
	aaa.obj.update_then_draw( self.ref.layer_a )
--	gol.pop_attrib()
end
