

function meu:define_meu_infos()
	return { author = "Mâa",
			tags = { "2d", "Core", "CoreGraphic", "texture", "input", "unfinished" },
			help = 	{
					"Show the state of the Fbo at the MEU Monitor position in the rendering chain",
					"  double click on the big fix Monitor in the MEU, open a window with a mobile monitor",
					"It is a dynamic Fbo inspector, move the MU around to see the Fbo states along the rendering chain.",
					"  internally this MEU execute low level texture copies (cost some GPU power)",
					"This copies can be accessed by MEUs used later:",
					"  MEU Monitor is also way to define a \"texture flux\" on the fly"
					}
		}
end

function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
	local bu
	local sha = self:get_shading()

	local ix,iy = 1,1
	local SY = 9
	local DY = .5

	ui.mon = self:add_monitor(			{ix,iy,		16,SY},		self:get_monitor_name(), 0 )
	iy = iy + SY + DY
	
	local names = { "1", "2", "3", "4", "ZBuf" }
	ui.mons = {}
	for i=1,5 do
		local mon = self:add_monitor(	{ix,iy,		4,SY/4},	names[i], 0  )
		mon:set_info_fxy( 2,3 )
		mon:set_method_on_click( self, "select_attachement", i )
		ui.mons[i] = mon
		if i==4 then
			ix = 1; iy = iy + SY/4
		else
			ix = ix + 4
		end
	end
	self.ui.mon_sx,self.ui.mon_sy = ui.mon:get_sxy()
end
function meu:init()
	self.__attachement_id = 1
end

function meu:__make_attachement_id( i )
	return i==5 and "depth" or i
end

function meu:select_attachement( i )
	self:print( "select_attachement( "..i.." )" )
	self.__attachement_id = self:__make_attachement_id( i )
--	aaa.show( self.__attachement_id, "att_id set" )
--	aaa.show( self.__attachement_id, "att_id" )
end

function meu:get_monitor_name()
	return "M"..self:get_inst_key()
end
function meu:__get_monitor_bind()
	local bind = self.__bind_monitor
	if not bind then
		local gp = GP.cur
		if gp then
			local name = self:get_monitor_name()
			local mon = gp:get_monitor( name )
			--self:print( "self:get_monitor_name() is "..name.." -> "..mon )
			if mon then
				bind = mon:get_texture_bind_2d() 
			else	--todo deal with this case
				local inst_key = self:get_inst_key()
				--self:print( "self:get_inst_key() is "..self:get_inst_key() )
				if		inst_key == "KinA1" then	bind = 256
				elseif	inst_key == "KinA2" then	bind = 256 + 32
				elseif	inst_key == "KinB1" then	bind = 256 + 32 * 2
				elseif	inst_key == "KinB2" then	bind = 256 + 32 * 3
				else
					local id = tonumber( inst_key )
					--hack
					if id then
						bind = TEXS.BIND_HACK_END - (tonumber( self:get_inst_key() ) - 1)
						self:print( inst_key.." "..id )
					else
						local id = tonumber( inst_key )
						self:show_error( "MEU Monitor only support certain names not "..inst_key )
						return TEXS.BIND_HACK_BEGIN
						--local m = self:get_meu_by_name_no_error( "fbo_"..inst_key )
						--bind = 
					end
				end
			end
			self.ui.mon:set_texture_bind_2d(bind)
			self:set_icon_bind(bind)
			self.__bind_monitor = bind
		end
	end
	return bind
end

function meu:update_ui()
	local mfbo = self:get_meu_fbo_used()
	if not mfbo then return end

	local ui = self.ui
	if self.bind_src then
		ui.mon:set_info_src_bind( self.bind_src )
	end

	local fbo = mfbo:get_fbo()
	local mons = ui.mons
	for i=1,5 do
		local id = self:__make_attachement_id(i)
		local b_active,bind = fbo:get_attachement_active(id),fbo:get_attachement_bind(id)
		--aaa.show( bind, "att "..id )
		local mon = mons[i]
		if mon then
			mon:set_active( true )
			local f = b_active and 1 or .75
--			mon:set_sxy( self.ui.mon_sx*f,self.ui.mon_sy*f )
			mon:set_texture_bind_2d( bind )
		end
	end
end

-- function meu:update()
-- end
-- function meu:draw_icon()
-- end

function meu:draw()
	local bind_dst = self:__get_monitor_bind()
	--self:print( bind_dst ) 
	if not bind_dst then return end

	local mfbo = self:get_meu_fbo_used()
	if not mfbo then return end

	--aaa.show( " to bind "..bind_dst, self.." Attachement_id "..self.__attachement_id )
	--todo add mipmap ui and pass arg
	local bind_src = mfbo:__copy_attachement_to_tex( self.__attachement_id, bind_dst, true, false )
	if bind_src then
		--aaa.img.move_from_gpu( bind_src )
		self.bind_src = bind_src
	end
	
	local ui = self.ui
	local mon_ass = ui.mon_associated
	if not mon_ass then
		mon_ass = ui.mon:get_gp_monitor_associated()
		ui.mon_associated =mon_ass
	end
	if mon_ass then
		--self:print( "set_info_src_bind "..self.bind_src )
		--self.ui.mon:set_info_src_bind( nil )
		mon_ass:set_info_src_bind( self.bind_src )
	end
end
