
function meu:define_meu_infos( )
	return { 	name_long = "Picture In Picture",
				author = "Mâa",
				tags = { "Texture", "Vj", "Core", "CoreGraphic", "2d", "Surface", "Draw" },
				help = {	"Display a Texture as a rectangle, Handle automatic fade",
							"deal with Mask, Incrustation, tint and so...",
							"In general Used in combination with MEUs Video."
						}
			}
end

function meu:__flip_incrust( t )
	t.min, t.max = t.max, t.min
end
function meu:add_incrust_pip( rect, name, x )
	local ix,iy, sx,sy = unpack(rect)
	local bu
	sy = sy / 2
	local t = {}
	self:add_button(			{ix+x,iy,		8-x-1.5,sy},	name,	t, "b_active",			false		):set_text_rect_ratio( 3 )
--	self:add_button(			{ix+6.5,iy,		1.5,sy},		"Inv",	self, "b_incrust_inverse",	false 	)
	self:add_trig_method(		{ix+6.5,iy,		1.5,sy},		"Flip",	self, "__flip_incrust", t )
	iy = iy + sy
	bu = self:add_slider_two(	{ix+x,iy,		8-x,sy},		"Luma", t, "min", "max", 0,1, 0,1 )
		bu:set_draw_step_linear( true )
	return  iy + sy, t
end

function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
	local bu
	local par
	local sha = self:get_shading()

	local SX,SY = 8,1
	local SYC = SY*.6
	local SY_TEX = 5.3
	local DY = .2
	local layer = self:get_layer(1)

	ref.map = aaa.layer.build_bank_bind_2d_ref_table( layer,1,4 )

	self:set_tab_key( "Main" )
	local ix,iy = 1,1
	
	bu = self:add_bu_texture(		{ix,iy,			8,SY_TEX},	"Tex", 1, false ) --todo use dir_maj
		ui.bu_tex = bu
	iy = iy + SY_TEX

	self:add_button(				{ix,iy,			2.5,SY},	"Inverse",	self, "b_inverse", false 	)
	iy, self.incrustation =
		self:add_incrust_pip(		{ix,iy,			SX,SY*2},	"Incrustation", 3	)

	local SYS = SY
	self:begin_bu_group( "mask" )
	self:add_trig_method(			{ix,iy-SYS+DY,	2.5,SYS},	"Swap",	self, "swap_texture_bind", 1,3 	)
	iy = iy + DY*2


	self:add_button(				{ix,iy,			2,SY},		"Mask",	self, "b_mask",		false 	)
	self:add_button(				{ix,iy+SY,		1.5,SY},	"Mul",	self, "b_mask_mul", false 	)
	self:add_button(				{ix+1.5,iy+SY,	1.5,SY},	"See",	self, "b_mask_see", false 	)


	iy, self.incrustation_mask =
		self:add_incrust_pip(		{ix,iy,			SX,SY*2},	"Remap", 3.5 	)
	self:end_bu_group()
	self:add_bu_texture(			{ix,iy,			8,SY_TEX},	"Mask Tex", 3, false ) --todo use dir_maj
	iy = iy + SY_TEX

	self:add_camera()

	ix,iy = 9,1 + 1 + DY
	bu = self:add_slider(			{ix+4,iy,		4,SY},		"delay",	self, "delay",	1, 0,16 )
--	bu = self:add_button( {8, iy }, "fade", self, "b_fade", false )
--	self.b_fade = true
	bu = self:add_button(			{ix,iy,			SY,SY},		"Sync",		self, "b_sync",	true	)
		bu:set_text_rect_ratio(1.8)
	--local SY = 1.2
	bu = self:add_trig(				{ix+2.8,iy,	 	1.2,SY},	"go",		self, "b_go",	false	)
		bu:set_text_rect_ratio(1)
		ui.bu_go = bu
	iy = iy + SY + DY

	self:add_size_uvf_video(		{ix,iy,			SX,SY*2}	)
	iy = iy + SY*2 + DY
	self:add_transfo(				{ix,iy,			8,2.4}		)
	iy = iy + 2.4 + DY

	self:add_rgbf(					{ix,iy,			8,SY}		)
	iy = iy + SY
	self:add_button(				{ix,iy,			2,SY},		"Tint",				sha:get_ref_frag_int(3)	)
	ui.bu_back	= self:add_rgbf(	{ix+2,iy,		6,SY},		"Background", false	)
	iy = iy + SY + DY

	--SY = SY * .8
	ui.bu_offset = self:add_rgbf(	{ix,iy,			8,SY},		"Offset", 	false )
	ui.bu_offset:set_rgb( 0,0,0)
	iy = iy + SY

	ui.bu_gamma = self:add_rgbf(	{ix,iy,			8,SY}, 		"Gamma",	false )
		:set_gamma(true)
	iy = iy + SY + DY
	--SY = SY / .8

	self:add_button(				{ix,iy,			2,SY}, 		"Clamp",			sha:get_ref_frag_int(2)	)
	self:add_button(				{ix+4-SY,iy,	SY,SY}, 	"Fuzzy active",		self, "b_fuzzy", false	)
		:set_text_visible( false )
	self:add_slider(				{ix+4,iy,		4,SY}, 		"Fuzzy",			self, "fuzzy", .01, 0,.25	)
	iy = iy + SY + DY

	self:add_blending( {ix,iy, 2,SY} )

	self:set_tab_key( "Map" )
	ix,iy = 1,1
	self:add_nb_uv(					{ix,iy,			SX,SY}		)
	iy = iy + SY + DY
	self:add_mapping_by_side_only(	{ix,iy, 		SX,SY}		)
	iy = iy + SY + DY
	self:add_mapping_hexa(			{ix,iy,			SX,SY*3}	)

end

function meu:set_texture( bind )	self:set_texture_bind_2d( 1, bind )	end
function meu:set_mask(    bind )	self:set_texture_bind_2d( 3, bind )	end

function meu:init()
	local sha = self:add_shading()
	sha:set_save_frag_int(		false,	1,4 )
	sha:set_save_frag_float(	false,	1,5 )
	sha:set_save_frag_vec4(		false,	1,1 )
	sha:set_save_frag_vec4(		false,	4,5 )
	sha:set_save_frag_vec4(		false,	8,8 )
end

function meu:is_fading()
	return self.time_fade ~= nil
end

function meu:__trig_fade()
	self.b_go						= false
	--todo dim_next is nil
	if self.time_fade then	-- case when a fade is trigged while a fade is already going on
		self.bind, self.dim	= self.bind_next, self.dim_next
		self.bind_next, self.dim_next = self.bind_2d_asked, self.dim_asked
		self.time_fade = self.delay - self.time_fade
	else
		self.bind_next, self.dim_next = self.bind_2d_asked, self.dim_asked
		self.time_fade = 0
	end
end

function meu:__stop_fade()
	if self.time_fade then
		--aaa.print_method()
		self.time_fade = nil
		if self.bind_next then
			self.bind		=	self.bind_next
			self.dim		=	self.dim_next
			self.bind_next	= nil
			--self:print( "__stop_fade() bind is "..self.bind )
		end
	end
end

function meu:update()
	local b_changed, bind_2d, dim = self.ui.bu_tex:get_bind_2d_dim_asked()
	if b_changed then
		self.bind_2d_asked, self.dim_asked = bind_2d, dim
	end

	if self.b_sync then
		if b_changed then
			self:__trig_fade()
		end	
	elseif self.b_go then
		self:__trig_fade()
	end

	self.bind_mask = self.b_mask and self:get_texture_bind_2d(3) or nil
	--self:print( self.bind_mask )
end

function meu:__draw_pip_low( dim, bind1, bind2, inter, alpha, bind_mask )	--todo restore dim
	--aaa.show( bind1.." ->"..bind2.."   "..inter )
--	bind1 = 33
--	bind2 = 37
	--aaa.print_fn()
	local ref = self.ref
	param.set( ref.tex_dim, dim )

	if bind1 then
	--	next line removed a bug 2022 April searching in C what is the problem	
	---		gol.set_tex_unit_2d_bind( 0, bind1  + 500 )
		self:set_bind_2d( bind1, 1 )
	--	gol.set_tex_unit_2d_bind( 0, bind1 )
	end
	if bind2 then
		self:set_bind_2d( bind2, 2 )
	--	gol.set_tex_unit_2d_bind( 1, bind2 )
	end

	ref.color:set_alpha( alpha )

	local sha = self:get_shading()
	sha:set_frag_float_1( inter )

	local t = self.incrustation
	if t.b_active then	sha:set_frag_float_2_3( t.min, t.max )
	else				sha:set_frag_float_2_3( 0, 0 )
	end

	if self.b_mask then
		gol.set_tex_unit_cur( 2 )
			gol.set_texture_dim( 2 )
			gol.bind_texture( bind_mask )
			gol.set_texture_dim( 2 )
		gol.set_tex_unit_cur( 0 )

		--gol.set_tex_unit_2d_bind( 2, bind_mask )
		local t = self.incrustation_mask
		if t.b_active then	sha:set_frag_float_4_5( t.min, t.max )
		else				sha:set_frag_float_4_5( 0, 0 )
		end
	end

	local ui = self.ui
	local r,g,b,a 
	r,g,b = ui.bu_offset:get_rgb()
	sha:set_frag_vec4( 5, r,g,b )

	r,g,b = ui.bu_gamma:get_rgb()
	sha:set_frag_vec4( 4, r,g,b )

	r,g,b = ui.bu_back:get_rgb()
	sha:set_frag_vec4( 1, r,g,b )

	local f = 100000
	if self.b_fuzzy then
		local fy = 1 / math.max(self.fuzzy*.5,1/f)
		--todo use grid size not texture
		local fx = fy * self:get_texture_ratio_x()
		sha:set_frag_vec4( 8,fx,fy )	
	else
		sha:set_frag_vec4( 8, f,f )
	end
	--self:print( r.." "..g.." "..b.." "..a )

	sha:set_frag_int( 1, self.b_inverse and 1 or 0 )
	local bf_mask
	if self.b_mask then
		bf_mask = 1
		if self.b_mask_see then	bf_mask = bf_mask + 16		end
		if self.b_mask_mul then	bf_mask = bf_mask + 16*16	end
	else
		bf_mask = 0
	end
	sha:set_frag_int( 4, bf_mask )

	--gol.dump_tex_unit()
	self:draw_layer( 1 )
	--gol.dump_tex_unit()
	--aaa.obj.update_then_draw( ref.__layer_marked )
end

function meu:draw()
	local ref = self.ref
	--self:print( "fade "..self.b_fade )
	local inter
	--if self.b_fade then
		local delay = self.delay
		if delay > 0 then
			inter = self.time_fade		
			if inter then
				inter = inter + aaa.time.dt
				--self:print( "time_fade -> "..inter )
				if inter > delay then
					self:__stop_fade()
					inter = nil
				else
					self.time_fade = inter
					inter = inter / delay
					--self:print( "fade inter is "..inter  )
				end
			end		
		else
			self:__stop_fade()
			inter = nil
		end
	-- else
	-- 	self:__stop_fade()
	-- 	inter = nil
	-- end
	self.ui.bu_go:set_text_color_busy( inter~=nil )

	--aaa.debug.debug()
	self:draw_layers_begin()
--[[
		if inter then
			--todo deal with no texture / fade to black
			--todo	fade to black/white then other
			--todo  have a nice fade even with no alpha
			--todo move to spip
			local color = ref.color
			local alpha = color:get_alpha()

			self:print( "\tinter -> "..inter )

			color:set_alpha( alpha )
			self:__draw_pip_low( self.dim, self.bind )

			color:set_alpha( alpha * (1-inter) )
			self:__draw_pip_low( self.dim_next, self.bind_next )

			color:set_alpha( alpha )
		else
]]--	
		--aaa.print( self.dim )
		local color = ref.color
		local alpha = color:get_alpha()

		self:__draw_pip_low( self.dim, self.bind, self.bind_next, inter or 0, self:get_alpha(), self.bind_mask )
		--self:__draw_pip_low( self.dim, 0, 32, 0, self:get_alpha() )
		--self:draw_layer( 1 )
	self:draw_layers_end()

--	self.ui.bu_go:print( "TEST" )
end
