
function meu:define_meu_infos( )
	return { 	author = "Mâa",
				tags = { "2d", "Vj", "Core", "CoreGraphic", "input", "output", "interoperability", "texture", "unfinished" },
				help =	{
							"Spout is a protocol to share low level graphic ressource",
							"Praticly it allows AAASeed to share in real time texture with other software",
							"You can \"Spout In\" (receive) or \"Spout Out\" (send) to/from other spout software.",
							"TouchDesigner, Smode, Unity, Millumin... to name only a few.",
							"there is spout software to send and receive image flux from machine to machine (e.g. NDI).",
							"with the use of OSC this is the base to work in conjunction with several software.",
 						}
			}
end

function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
	local bu
	local par
	local ix,iy = 1,1
	local SY = .8
	local DY = .2

	bu = self:add_trig_fn(				{ix,iy,		4,SY},	"Focus",	aaa.obj.set_focus_ui, ref.spout2 )
	iy = iy + SY + DY
	local SYM = 7
	self:add_bu_texture_target_unit( 	{ix,iy, 	8,SYM},	"Spout2 Image", 1, false )
	bu = self:add_monitor( 				{ix,iy+SYM,	8,SYM},	"Src" )
		bu:set_render_mode_alpha( 0 )

	ui.bu_name = bu

	ix,iy = 9,1
	ui.bu_name = self:add_text_info(	{ix,iy,		8,SY}, "name" )
	ui.bu_info = self:add_text_info(	{ix,iy+1,	8,SY}, "State" )

	iy = 3.25

	local SX = 2
--	self:add_button( {		ix, iy + 3 },		"Enum Sender",		self, "b_enum_sender",	false	)

	self:add_button(	{ix,	iy,		3,SY},		"Receive",			ref.receive,			nil,	false	)
	self:add_button(	{ix+3,	iy,		2,SY},		"Receive Image",	ref.receive_image,		nil,	false	):set_text( "Image" )
	self:add_button(	{ix+5,	iy,		2,SY},		"Receive DX9",		ref.receiver_dx9_asked, nil,	false	):set_text( "DX9" )

	iy = iy + SY
	self:add_button(	{ix+5,	iy,		2,SY},		"receive V Flip",	ref.receiver_vertical_flip,	nil,	false	):set_text( "V Flip" )
	iy = iy + SY + DY
	local SYT = .6
	self.ui.bu_spout_nb = self:add_text_info(	{ix,iy,	8,SYT}, "spout_nb"	)
	iy = iy + SY
	self:add_slider(	{ix,	iy,		8,SY},		"Receive Index", 	ref.receiver_index,		nil, 	0, 	0,15 	)
	iy = iy + SY
	self.ui.bu_flux_used = self:add_text_info(	{ix,iy,	8,SYT}, "flux used"	)
	iy = iy + SYT*2 + DY
	self:add_button( 			{ix,iy,		4,SY},	"Control Next", 		self,		"b_control_next", 			false	)
	bu = self:add_text_info(	{ix+4,iy,	4,SY},	"Control Info" )
		bu:set_value_load_save( false )
		ui.bu_control_info = bu
	iy = iy + SY*2


	self:add_text_info(	{ix,	iy,		8,.7}, 		"Spout Out" )
	iy = iy + SY + DY
	self:add_button( 	{ix,	iy,		3,SY},		"Send",				ref.send,			  nil,	false	)
	self:add_button( 	{ix+3,	iy,		2,SY},		"Send Image",		ref.send_image,       nil,	false	):set_text( "Image" )
	self:add_button( 	{ix+5,	iy,		2,SY},		"Send DX9",			ref.sender_dx9_asked, nil,	false	):set_text( "DX9" )
	iy = iy + SY
	self:add_button(	{ix+5,	iy,		2,SY},		"send V Flip",		ref.sender_vertical_flip,	nil,	false	):set_text( "V Flip" )
	iy = iy + SY + DY
	self.ui.bu_spout_out = self:add_text_info(	{ix,iy,	16,.6}, "spout_Out"	)
--	self:add_button( {		ix, iy + 3 },			"Enum Sender",		self, "b_enum_sender",	false	)
--	self.ui.bu_spout_nb = self:add_text_info(	{ix,iy + 4,	16,.6}, "spout_nb" )

end

local function pgr( ref, name, obj, pname )
	ref[name]	=	param.get_ref(	obj, pname and pname or name )
end
function meu:init()
	local ref = self.ref
	--ref.spout2	= self:get_obj_down( "bdd_spout2" )
--	ref.bdd_cv_writer =aaa.layer.get_bdd( self:get_layer(1) )
	ref.spout2 = aaa.layer.get_bdd( self:get_layer(1) )
	local o = ref.spout2
		pgr( ref, "receive",				o	)
		pgr( ref, "receiving",				o	)
		pgr( ref, "receiving_count",		o	)
		pgr( ref, "receiver_name",			o	)
		pgr( ref, "receiver_index",			o	)
		pgr( ref, "receive_image",			o	)
		pgr( ref, "receiver_vertical_flip",	o	)

		pgr( ref, "send",					o	)
		pgr( ref, "sender_name",			o	)
		pgr( ref, "send_image",				o	)
		pgr( ref, "sending",				o	)
		pgr( ref, "sending_count",			o	)
		pgr( ref, "sender_vertical_flip",	o	)

		pgr( ref, "size_x",					o	)
		pgr( ref, "size_y",					o	)
--		pgr( ref, "memory_share",			o	)
		pgr( ref, "sender_dx9_asked",		o	)
		pgr( ref, "receiver_dx9_asked",		o	)
--		pgr( ref, "is_dx9",					o	)

		pgr( ref, "receiver_sender_count",		o	)
		pgr( ref, "receiver_sender_enum_trig",	o	)

		param.set( ref.sender_name, "AAASeed Garden "..self:get_inst_key() )
end

function meu:is_send()			return param.get_bool( self.ref.send 		)	end
function meu:is_sending()		return param.get_bool( self.ref.sending 	)	end
function meu:is_receive()		return param.get_bool( self.ref.receive		)	end
function meu:is_receiving()		return param.get_bool( self.ref.receiving	)	end

--function meu:is_memory_share()	return param.get_bool( self.ref.memory_share )	end
function meu:is_dx9()			return param.get_bool( self.ref.is_dx9		)	end

function meu:update_ui()
	local	pg	= param.get
	local 	ref	= self.ref
	local	ui	= self.ui
	local	sx = pg( ref.size_x )
	local	sy = pg( ref.size_y )

	local bu = ui.bu_info
	local str
	local b_sending		= self:is_sending()
	local b_receiving	= self:is_receiving()
	local b_send		= self:is_send()
	local b_receive		= self:is_receive()
	local color

	if b_sending then
		if b_receiving then	str = "Receiving and Sending"
		else				str = "Sending"
		end
		color = {0,1,0,1}
	elseif b_receiving then	str = "Receiving"	color = {0,1,0,1}
	else					str = "Neither"		color = {1,0,0,1}
	end
	bu:set_text_color( color )
	bu:set_text( str.." "..sx.." by "..sy )

	if b_send then
		if b_receive then	str = "Receive and Send"
		else				str = "Send"
		end
	elseif b_receive then	str = "Receive"
	else					str = "Neither"
	end
--[[
	local str2
	if self:is_memory_share() then		str2 = "Memory Share"		
	elseif self:is_dx9() then			str2 = "DX9"
	else								str2 = "DX11"
	end
	str = str .. " "..str2
--]]
	ui.bu_name:set_text( str )

	ui.bu_spout_nb:set_text( "Receiver Sender Count : "..param.get( self.ref.receiver_sender_count) )
	ui.bu_flux_used:set_text( param.get( ref.spout2, "src_"..param.get(ref.receiver_index) ).."\n"..param.get(ref.receiving_count) )
	ui.bu_spout_out:set_text( param.get( ref.sender_name ).."\n"..param.get(ref.sending_count) )

	local bu = ui.bu_control_info
	if self.b_control_next then
		if self.__mu_dir_kinect_process then
			--if not self.__b_frame_new then
				bu:set_text( self.__b_frame_new and "Dir Ok" or "Dir Skip" ) 
			--end
		end
	else
		bu:set_text( "No" ) 
	end

end


function meu:draw()
	local ref = self.ref

	self:draw_layers_begin()

		self:draw_layer(1)

		if self:is_receiving() then
			local frame_index = param.get(ref.receiving_count)
			self.__b_frame_new = self.__frame_index_last ~= frame_index
			if self.__b_frame_new then
				self.__frame_index_last = frame_index
			end
		else
			self.__b_frame_new = false
		end
		local b_skip = self.b_control_next and (not self.__b_frame_new)

		local m = self.__mu_dir_kinect_process
		if not m then
			local name = self:get_inst_key()
			m = self:get_mu_by_name_no_error( "Dir_KinectA" )
			if m then
				self.__mu_dir_kinect_process = m
				self:print( "found dir mu to control "..m  )
			else
				self:print_error( "no Dir or MuBegin to control" )
			end
		end
		if m then
			m:set_render_skip_next( b_skip )
		end

	self:draw_layers_end()	
end