function meu:define_meu_infos( )
	return { 	author = "Mâa",
				version = 0,
				tags = { "2d", "3d", "Vj", "coregraphic", "imageprocessing", "text", "unfinished" },
				help =	{	"Basic Meu to display text and load font (double click on a selector item).",
							"Font can be otf, ttf or Json (AAASeed use of SDF font)."
						}
			}
end

function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
	local bu
	local par

	local SY = 1
	local DY = .2
	local ix,iy = 1,1
	
	self:add_rendering()

	local SYS = 5
	bu = self:add_selector( {ix,iy,	8,SYS}, "Font" )
		bu:set_nb_min_0( 8, 8 )
		bu:set_item_text_from_nb()
		bu:set_target_param( ref.font )
		bu:set_method_on_click_double( self, "load_font" )
		--todo try to optimize later using this
		--bu:set_method_on_value_change( self, "change_font" )
		ui.bu_font_selector = bu
	iy = iy + SYS + DY

	bu = self:add_text_info( {ix,iy,	16,SY},	"Font Name" )
		ui.font_name = bu
	iy = iy + SY + DY

	bu = self:add_text( {1,iy, 16,SY}, "text" )
		bu:set_text( param.get( self.ref.text ) )
		bu:set_text_type(3)
	--todo this don't function
	--bu:set_target_param( ref.text )
	ui.bu_text = bu 
	iy = iy + SY + DY

	local iy_mon = iy

	self:add_camera()
	ix = 9
	iy = 2 + DY
	self:add_transfo( {ix,iy, 8,2.4}, 1 )
	iy = iy + 2.4 + DY
	self:add_rgbf( {ix,iy, 8,SY} )
end

function meu:init()
	local ref = self.ref

	ref.bdd		=	self:get_layer_bdd( 1 )
	ref.text	=	param.get_ref( ref.bdd, "text" )
	ref.font	=	param.get_ref( ref.bdd, "font" )
	ref.font_name = param.get_ref( ref.bdd, "font_name" )

	local app = aaa.obj.get_from_top_by_class( "app" )
	local param_font_bind = param.get_ref( app, "font->" )
	ref.font_bind = param.get_obj_attached( param_font_bind ) 
end

function meu:set_text( str )
	param.set( self.ref.text, str )
end

function meu:load_font( id )
	local ref = self.ref
	local ui = self.ui
	local bind = ui.bu_font_selector:get_value()
	local str = "load font at index "..bind
	local filter = "Reconnus\0*.ttf;*.otf\0Ttf\0*.ttf\0Otf\0*.otf\0Tous\0*.*\0\0"
	local filenames = aaa.file.do_dialog_open( str, filter, true )
	table.print( filenames, "filenames" )
	for i,fname in IPAIRS(filenames) do
		self:print( i.." load "..fname.." at "..bind )
		param.set( ref.font_bind, "bind_"..aaa.format.int_to_char2(bind), fname )
		bind = bind + 1
	end
end
function meu:get_font_name()
	local ref = self.ref
	local ui = self.ui
	local bind = ui.bu_font_selector:get_value()
	return param.get( ref.font_bind, "bind_"..aaa.format.int_to_char2(bind) )
end
function meu:update_ui()
	local ui = self.ui
	local font_name = self:get_font_name()
	ui.font_name:set_text( font_name )
end

function meu:update()
	local ref = self.ref
	local ui = self.ui
	local str = ui.bu_text:get_text()
	param.set( ref.text, str )

	local font_name = self:get_font_name()
	--self:print( "Toto ".. string.sub( font_name, -5).." "..(string.sub( font_name, -5)==".json") )
	param.set( ref.layer[1].use_shading, (string.sub( font_name, -5)==".json") and 2 or 1 )
end

--[[ from sdf MEU
function meu:define_ui()
	local ref = self.ref
	local ui = self.ui
	local bu

	self:add_camera()

	local ix = 1
	local iy = 1
	local SY = .9
	local DY = .2

	iy = 2
	ui.bu_info = self:add_text_info(	{ix,iy,	16,SY},	"Text" )

	iy = 3

	ui.bu_text_color	= self:add_rgbfa(	{ix,iy,	6,SY * 4}, "Text Color", 		false )

	iy = iy + SY * 5
	bu = self:add_slider(	{ix,iy,	8,SY},		"Linelenght",		self, "linelenght",			0,		0, 100 )


	--local i = 1;

	--self.str = "AAASeed MSDF Text :\n- Ligne 2\n- Ligne 3"
	self.str = "Au nord-est de la côte australienne, le plus grand ensemble corallien du monde offre, avec ses 400 espèces de coraux, ses 1 500 espèces de poissons et ses 4 000 espèces de mollusques, un spectacle d’une variété et d’une beauté extraordinaires et d’un haut intérêt scientifique.\nC’est aussi l’habitat d’espèces menacées d’extinction, comme le dugong et la grande tortue verte."
	self.text = TEXT:create( "SDF Text" )

end

function meu:init()
	local ref = self.ref
end

function meu:update_ui()
	local ui = self.ui
	local ref = self.ref
	local str = string.sub( self.str, 1, 40 )
	ui.bu_info:set_text( str )
end

function meu:draw()
--	local ui = self.ui
 	self:draw_layers_begin()
 		self:draw_layer( 1 )
 	self:draw_layers_end()

	local text = self.text

	text:set_font_sdf(5)
	text:set_font_type( "FONT_SDF" )
	text:set_alignment( "center" )
	text:set_justification( "left" )
	text:set_line_lenght( self.linelenght )
	--local str = self.str.." : "..aaa.time.dt
	text:set_color( self.ui.bu_text_color:get_rgba() )
	text:draw( 1, self.str, 0, 0, 2.0, 2.0 )

end
--]]
