#if USE_AAA_UNIFORM == 1
#else
#endif


#define time aaa_fu_float[0]

layout(binding = 0) uniform sampler2D tex_reel_1;
layout(binding = 1) uniform sampler2D tex_reel_2;
layout(binding = 2) uniform sampler2D tex_reel_3;

layout(location = 0) out vec4 out_result;

void main(void)
{
    vec2 uv = gl_FragCoord.xy / vec2(aaa_resolution); // Normalized UV
    
    float reel_width = 1.0 / 3.0;
    vec4 color;

    if (uv.x < reel_width) {
        float scroll = mod(time * 0.5, 1.0); // Vitesse de scroll
        vec2 reel_uv = vec2(uv.x * 3.0, mod(uv.y + scroll, 1.0)); 
        color = texture(tex_reel_1, reel_uv);
    }
    else if (uv.x < 2.0 * reel_width) {
        float scroll = mod(time * 0.7, 1.0);
        vec2 reel_uv = vec2((uv.x - reel_width) * 3.0, mod(uv.y + scroll, 1.0));
        color = texture(tex_reel_2, reel_uv);
    }
    else {
        float scroll = mod(time * 0.9, 1.0);
        vec2 reel_uv = vec2((uv.x - 2.0 * reel_width) * 3.0, mod(uv.y + scroll, 1.0));
        color = texture(tex_reel_3, reel_uv);
    }

    out_result = color;
}



