if CLASS.DECLARE( "TEXT", nil, {ref = {}} ) then
	TEXT:set_class_status_doc(	CLASS.STATUS.CORE,
								"use a c Layer with bdd_text to display text" )

	local ref = TEXT.ref
	local pgr = param.get_ref
	local function pgr( ... )
		local r = param.get_ref(...)
		param.set_save( r, false )
		return r
	end
	local o = aaa.get_caller()
	o = aaa.obj.get_root( o )
	ref.layers = o
	aaa.obj.update_then_draw( ref.layers )	--make sure it is updated so we have a color object
	ref.text_layer			= aaa.obj.get_branch_by_name_symbo( o, "gabu_text_layer" )
		--	todo change name to avoid confusion
		ref.text_color			= aaa.layer.create_color( ref.text_layer, "text" )
	ref.text_model			=	aaa.layer.get_model( ref.text_layer )
		ref.text_su				=	pgr( ref.text_model, "size_u" )
		ref.text_sv				=	pgr( ref.text_model, "size_v" )
		ref.text_sf				=	pgr( ref.text_model, "size_factor" )
	ref.text_bdd			= aaa.obj.get_branch_by_name_symbo( ref.text_layer, "gabu_text_bdd" )
		ref.text_x				=	pgr( ref.text_bdd, "origin_x" )
		ref.text_y				=	pgr( ref.text_bdd, "origin_y" )
		ref.text_str			=	pgr( ref.text_bdd, "text" )

	-- ref needed for TEXT using bdd_text
	ref.text_type				= pgr( ref.text_bdd, "type" )
	ref.text_font 				= pgr( ref.text_bdd, "font" )
	ref.text_id 				= pgr( ref.text_bdd, "buffer_id" )
	ref.text_alignment 			= pgr( ref.text_bdd, "alignment" )
	ref.text_alignment_vert		= pgr( ref.text_bdd, "alignment_vertical" )
	ref.text_justification		= pgr( ref.text_bdd, "text_justification" )
	ref.text_interline	 		= pgr( ref.text_bdd, "interline" )
	ref.text_line_lenght 		= pgr( ref.text_bdd, "line_lenght" )
	ref.text_draw_box	 		= pgr( ref.text_bdd, "draw_bbox" )
	ref.text_face_size	 		= pgr( ref.text_bdd, "face_size" )
	ref.text_face_dpi	 		= pgr( ref.text_bdd, "face_dpi" )

	ref.text_width	 			= pgr( ref.text_bdd, "width" )
	ref.text_height	 			= pgr( ref.text_bdd, "height" )

	ref.mapping				= aaa.layer.get_mapping( ref.text_layer )
		ref.tex_dim				= pgr( ref.mapping, "tex_use" )
	ref.shading				= aaa.layer.get_shading( ref.text_layer )
		ref.shading_active		= pgr( ref.shading, "active" )
		ref.shading_color_r		= pgr( ref.shading, "fu_01_r_x" )
		ref.shading_color_g		= pgr( ref.shading, "fu_01_g_y" )
		ref.shading_color_b		= pgr( ref.shading, "fu_01_b_z" )
		ref.shading_color_a		= pgr( ref.shading, "fu_01_a_w" )

	TEXT.font_type_str	=	{
							"MAA_LINE", "GLUT_LINE",
							"FONT_TEXTURE", "FONT_BUFFER",
							"FONT_OUTLINE", "FONT_POLYGON", "FONT_EXTRUDE",
							"FONT_BITMAP", "FONT_PIXMAP", "FONT_SDF"
							}

	TEXT.last = {}
end

--
-- SET/GET
--
function TEXT:set_font_type( val )
	local strs = self.font_type_str
	for i = 1, #strs do
		if strs[i] == val then
			self.font_type = i - 1 	-- index begins at 0 in aaaseed
			break
		end
	end
end

function TEXT:get_font_type()		return self.font_type_str[self.font_type+1]	end

function TEXT:set_face_size( val )	self.face_size = val	end
function TEXT:get_face_size()		return self.face_size	end

function TEXT:set_face_dpi( val )	self.face_dpi = val		end
function TEXT:get_face_dpi()		return self.face_dpi	end

function TEXT:set_font( val )		self.font_index = clamp( val, 0, 64 )	end
function TEXT:get_font()			return self.font_index					end

function TEXT:get_alignment()		return self.alignment			end
function TEXT:set_alignment( val )
-- values are Left, Center, Right, Justify
	self.alignment = val
	if val ~= "center" and val ~= "right" and val ~= "justify" then
		self.alignment = "left"		-- default value
	end
end

function TEXT:get_alignment_vert()		return self.alignment_vert		end
function TEXT:set_alignment_vert( val )
-- values are top_line, middle, bottom_line
	self.alignment_vert = val
	if val ~= "middle" and val ~= "bottom_line" then
		self.alignment_vert = "top_line"			-- default value
	end
end

function TEXT:get_justification()		return self.justification		end
function TEXT:set_justification( val )
-- values are Left, Center, Right, Justify
	self.justification = val
	if val ~= "center" and val ~= "justify" and val ~= "right" then
		self.justification = "left"			-- default value
	end
end


function TEXT:get_interligne()			return self.interligne			end
function TEXT:set_interligne( val )		self.interligne = val			end

function TEXT:get_line_lenght()			return self.line_lenght			end
function TEXT:set_line_lenght( val )	self.line_lenght = val			end

function TEXT:get_draw_box()			return self.b_draw_bbox			end
function TEXT:set_draw_box( b )			self.b_draw_bbox = b			end

function TEXT:get_width()				return param.get( self.ref.text_width )		end
function TEXT:get_height()				return param.get( self.ref.text_height )	end

function TEXT.set_font_low( index )
	local ref = TEXT.ref
	param.set( ref.text_font, 	index )
end
function TEXT.set_color_low( r,g,b, a )
	local ref = TEXT.ref
	ref.text_color:set_rgba( r,g,b, a )
end

function TEXT:set_color_sdf( r,g,b, a )	self.color = { r,g,b, a }		end
function TEXT:set_color( r,g,b, a )		self:set_color_sdf( r,g,b, a )	end

function TEXT.__draw_base( str, x,y, sx,sy )
	local ref = TEXT.ref
	local pset = param.set
	local l = TEXT.last
	if l.x ~= x then
		pset( ref.text_x, x )
		l.x = x
	end
	if l.y ~= y then
		pset( ref.text_y, y )
		l.y = y
	end
	if l.sx ~= sx then
		pset( ref.text_su, sx )
		l.sx = sx
	end
	if l.sy ~= sy then
		pset( ref.text_sv, sy )
		l.sy = sy
	end
	param.set( ref.text_str, str )

	aaa.obj.update_then_draw( ref.text_layer )
	gol.set_texture_dim(0)
end

function TEXT:draw( id, text, x,y, sx,sy )
	if not self:is_active() then return end
	--if true then return end
	if not text then return end
	--text = "TEXT TO TEST"
	--self:print( "TEXT "..id..", draw() "..text )
	--self:print( self.font_type)
	--self:print( "self.buffer_index".. self.buffer_index )

	--self.font_type = 2
	if self.font_type > 1 then
		local ref = TEXT.ref
		local pset = param.set
		local last = TEXT.last
		if last.font_type ~= self.font_type then
			pset( ref.text_type,			self.font_type )
			--self:print( "self.text_type "..self.font_type )
			last.font_type = self.font_type
		end
		-- ftgl stuff
		--self:print( self.font_index )
		if last.font_index ~= self.font_index then
			pset(	ref.text_font, 				self.font_index			)
			last.font_index = self.font_index
		end
		--if self.font_index  ~= 0 then
		--	self:print( "self.font_index "..self.font_index )
		--end
		if last.alignment ~= self.alignment then
			pset(	ref.text_alignment, 		self.alignment			)
			last.alignment = self.alignment
		end
		if last.alignment_vert ~= self.alignment_vert then
			pset(	ref.text_alignment_vert, 	self.alignment_vert	)
			last.alignment_vert = self.alignment_vert
		end
		if last.justification ~= self.justification then
			pset(	ref.text_justification, 	self.justification	)
			last.justification = self.justification
		end
		if last.interligne ~= self.interligne then
			pset(	ref.text_interline, 		self.interligne			)
			last.interligne = self.interligne
		end
		if last.line_lenght ~= self.line_lenght then
			pset(	ref.text_line_lenght, 		self.line_lenght		)
			last.line_lenght = self.line_lenght
		end
		if last.b_draw_bbox ~= self.b_draw_bbox then
			pset(	ref.text_draw_box, 			self.b_draw_bbox		)
			last.b_draw_bbox = self.b_draw_bbox
		end
		if last.face_size ~= self.face_size then
			pset(	ref.text_face_size, 		self.face_size			)
			last.face_size = self.face_size
		end
		if last.face_dpi ~= self.face_dpi then
			pset(	ref.text_face_dpi, 			self.face_dpi			)
			last.face_dpi = self.face_dpi
		end

		if self.font_type == 9 then
			pset( ref.shading_active, 1 )
			pset( ref.tex_dim, 2 )
			pset( ref.text_id, id )
			param.set( ref.shading_color_r, self.color[1] )
			param.set( ref.shading_color_g, self.color[2] )
			param.set( ref.shading_color_b, self.color[3] )
			param.set( ref.shading_color_a, self.color[4] )
		else
			pset( ref.shading_active, 0 )
			pset( ref.tex_dim, 0 )
			pset( ref.text_id, 0 )
		end


		TEXT.__draw_base( text, x, y, sx, sy )	--solve once for all the factor stuff we need a get_str_translate fn for this case too
	else
		sx = sx * 0.66666666
		sy = sy * 0.66666666
		aaa.draw_str_xy( text, x, y, sx, sy )
		--self:print( "we should not pas here" )
	end
end

function TEXT:set_font_texture( font )
	self.font_type = 7
	self:set_font( font )		-- arial
	self:set_face_size( 144 )
	self:set_face_dpi( 36 )
	self:set_alignment( "left" )
	self:set_alignment_vert( "top_line" )
	self:set_interligne( 1. )
	--self:set_line_lenght( 200 )
end

function TEXT:set_font_sdf( font )
	self.font_type = 9
	self:set_font( font )		-- Helvetica SDF
	--self:set_face_size( 144 )
	--self:set_face_dpi( 36 )
	self:set_alignment( "left" )
	self:set_alignment_vert( "top_line" )
	self:set_justification( "left" )
	self:set_interligne( 1. )
--	self:print( "self.font_type "..self.font_type )
--	self:print( "font "..font )
	--self:set_line_lenght( 200 )
end

function TEXT:create( name )
	local self = TEXT:create_instance( name )

	self.font_type		= 0
	self.font_index		= 0
	self.alignment		= "left"		-- values are left, center, right, justify
	self.alignment_vert	= "top_line"	-- values are top_line, middle, bottom_line
	self.justification 	= "left"		-- values are left, center, justify, right
	self.interligne		= 1.
	self.line_lenght	= 320
	self.b_draw_bbox	= false
	self.face_dpi		= 36
		self.face_size		= 144
		self.color = { 1, 1, 1, 1 }
	return self
end


