--require('mobdebug').start()
--[[
local function draw_star( x, y, nb, r )
	r = r * 1
	local rm = r * .4
	--local ri = r * .25
	local da = math.pi * 2 / nb
	local sin = math.sin
	local cos = math.cos
	local a = math.pi * .5
	local dda = da * .5
	for i=1,nb-1 do
		gol.draw_line_strip_2d(	x + rm*cos(a-dda),	y + rm*sin(a-dda),
								x + r *cos(a),		y + r *sin(a),
								x + rm*cos(a+dda),	y + rm*sin(a+dda)
								--x + ri*sin(a),		y + ri*cos(a),
								)
		a = a + da
	end
end
--]]

function BU:add_dialog_message( str )
	local x,y = self:convert_xy_local_to_top( -1,0 )
	ga:add_dialog_message( self.."\n"..str, {x,y} )
end

function BU:get_uif_verbose()	return self.__uif_verbose		end
function BU:set_uif_verbose(s) 	self.__uif_verbose = s 			end

--	uif -> User Interface Fast
BU.doc.is_uif_enabled = "() return true if UIF is enabled"
function BU:is_uif_enabled()	return self.__b_uif_enabled		end
function BU:enable_uif()
	--self:box_debug( "enable_uif()" )
	self.__b_uif_enabled = true
end
function BU:disable_uif()
	--self:box_debug( "disable_uif()" )
	self.__b_uif_enabled = false
end

BU.doc.is_uif = "() return true if UIF is to be used"
function BU:is_uif()
	--aaa.print_fn()
	if not self.__b_uif_enabled then
		if self:get_uif_verbose() > 0 then
			self:print_debug( "UIF is_uif(): disabled" )
		end
		return false
	end

	--self:print( "uif testing shift "..BU.__b_uif_on_shift )
	--self:print( "BU:is_uif() aaa.keyboard.is_shift() "..BU.__b_uif_on_shift.." "..aaa.keyboard.is_shift() )
	if BU.__b_uif_on_shift then
		return aaa.keyboard.is_shift()
	end

	--self:print( "uif ok")
	return true
end


function BU:get_uif_bui()
	self:print( "BU have no BUI" )
end
function BU:add_uif_zones_base( zones, dist, x,y )
	local SX,SY = 1.5,.8
	local DX = .1
	local SXT = SX*4 + DX*3
	x = x or -SXT/2
	y = y or 0
	x = x + SX/2
	DX = DX + SX

	zones.Name		=	{	type="button",		angle=3/4,		dist=dist,	rect={x,y,	SX,SY}	}
	x = x + DX
	zones.Values	=	{	type="button",		angle=3/4,		dist=dist,	rect={x,y,	SX,SY}	}
	x = x + DX
	zones.Dump		=	{	type="button",		angle=3/4,		dist=dist,	rect={x,y,	SX,SY}	}
	x = x + DX
	if ga.bu_doc then
		zones.Doc	=	{	type="button",		angle=3/4,		dist=dist,	rect={x,y,	SX,SY}	}
	end

end
function BU:get_uif_zones()
	if true then
		local zones = {}
		self:add_uif_zones_base( zones, 2 )
		--zones.ZO	= {	angle=3/4,			dangle=1/4,	dist=.7,	}
		return zones
	else
		-- 	self:print( "BU have no get_uif_zones()" )
	end
end

function BU:__process_uif_name( name )
	if name then
		-- force name to lower case
		name = string.lower(name)
		-- replace space by _
		name = string.gsub( name, " ", "_" )
		return name
	end
end
function BU:get_uif_name_sel( uif )
	return uif.__name_sel
end
function BU:is_uif_name_sel( uif, name )
	return self:__process_uif_name(name) == BU:get_uif_name_sel(uif)
end

function BU:do_uif_command( uif )
	local command = BU:get_uif_name_sel( uif )
	aaa.print_fn()

	-- local b_used = true 
	-- if	command == "dump"	then	self:dump( 2 )
	-- else							b_used = false 
	-- end

	local b_used = false
	return GABU_OBJ.do_uif_command_with_super( self, b_used, uif, BU )
end




function BU:is_uif_running() 			return self.__uif_b_running		end
function BU:begin_uif( x,y,	origin )
	--aaa.print_fn()
	--self:set_uif_verbose(1)
	--todouif add ui to control this
	if not self:is_uif() then
		return false
	end
	-- if not aaa.keyboard.is_shift() then
	-- 	return false
	-- end

	local time = self.uif_end_time
	if time then
		if aaa.time.t > time + 1. then -- 0.2 sec had passed
			self.uif_end_time = nil
			--self:print_error( "end blocking with tempo" )
		else
			--self:print_error( "Too soon to start UIF again" )
			if self:get_uif_verbose() > 0 then
				self:print_debug( "UIF begin_uif(): Too soon to start UIF again" )
			end
			return false
		end
	end

	if self:get_uif_verbose() > 0 then
		self:print_debug( "BU:begin_uif() from "..origin )
		--table.print( self, "BU" , 1 )
	end

	if self.__b_uif_outside then
		if origin ~= "mouse_move" then
			self.__uif_time_begin = aaa.time.t
			if self:get_uif_verbose() > 0 then
				self:print_debug( "origin "..origin.." not a move so can't begin uif" )
			end
			return false
		end

		if inside( x, -.5,.5 ) and inside( y, -.5,.5 ) then
			if self:get_uif_verbose() > 0 then
				self:print_debug( "inside BU so can't begin uif" )
			end
			return false
		end
		-- self.__uif_time_begin happeedn to be nil once
		local delay = self.__uif_time_begin and (aaa.time.t - self.__uif_time_begin) or 0
		if delay > .2 then
			if self:get_uif_verbose() > 0 then
				self:print_debug( "too long ("..delay..") before going out " )
			end
			return false
		end 		
	else
		if origin ~= "action_down" then
			if self:get_uif_verbose() > 0 then
				self:print_debug( "not a down so can't begin uif" )
			end
			return false
		end
	end 

	local zones = self:get_uif_zones()
	--table.print( zones )
	if not zones then
		if self:get_uif_verbose() > 0 then
			self:print_debug( "UIF begin_uif(): No Zones" )
		end
		return false
	end
	
	--aaa.print_fn()
	if self.__uif_verbose > 0  then	--todouif add ui to control thiss
		if origin then
			self:print( "begin_uif() called for "..origin )
		else
			self:print( "begin_uif()" )
		end
	end

	local bui = self:get_uif_bui()
	if bui then
		if bui.get_id_interacting then	--todo this a way to validate again that this a bui, we could do better: is derived from
			local id = bui:get_id_interacting()
			bui.__uif_val_cano_begin = bui:get_value_cano_clamped(id)
			bui.__uif_val_begin = bui:get_value(id)
			self.__uif_bui = bui
		else
			self:print_error( "BU:begin_uif() bui is not a BUI here" )
		end
	else
		self:print( "BU:begin_uif() no BUI" )
	end
	
	ga:register_uif( self )
	self.__uif_b_running = true
	local uif = { zones=zones }
	self:set_uif_data( uif )
	uif.time_begin = aaa.time.t
	self:__make_uif_data( x,y, true )
	return true
end

function BU:end_uif( b_block_tempo, origin ) 
	if self.__uif_verbose > 0 then
 		if origin then
			self:print( "end_uif() called from "..origin )
		else
			self:print( "end_uif()" )
		end
	end
	if self:is_uif_running() then 
		self.__uif_b_running = false
		local bui = self.__uif_bui
		if bui then
			self.__uif_bui = nil
			bui.__uif_val_cano_begin = nil
			bui.__uif_val_begin = nil
		end
		self:set_uif_data( nil )
		ga:unregister_uif( self )
	else
		self:print_error( "uif not running" ) 
	end
	if b_block_tempo then
		self.uif_end_time = aaa.time.t
	end
end

function BU:__make_uif_data( x,y, b_begin )
--	aaa.print_fn()
	x,y = self:convert_xy_local_to_top( x,y )
	local xb,yb
	if b_begin then
		xb,yb = x,y
		self.__uif_x_begin, self.__uif_y_begin = x,y
	else
		xb,yb = self.__uif_x_begin,	self.__uif_y_begin
	end

	local uif = self:get_uif_data()
	uif.x_begin,uif.y_begin = xb,yb
	uif.x,uif.y = x,y

	local bui = self.__uif_bui
	if bui then
		bui:set_uif_data( uif )
	end
	--table.print( uif, "uif", 2 )

--	if self:is_contact() then
	local dx = x - xb
	local dy = y - yb
	--aaa.print( "UIF dx, dy : "..dx..", "..dy )
	--uif.dx_to_begin	= dx
	--uif.dy_to_begin	= dy
	local d = math.sqrt( dx*dx + dy*dy )
	--uif.d_to_start	= d

--	local u,du
--	local du

	if d < self.UIF_NEUTRAL then
		uif.__zone_sel = nil
		uif.__name_sel = nil
	else
		--self:print( dy )
		--min/max
		--du = dx==0 and 0 or (dx<0 and -1 or 1)
		local name_sel
		local zone_sel
		
		local ac = math.atan2( dy, dx ) * math.pi2_over
		if ac < 0 then ac = ac + 1. end
		--aaa.show( ac, "angle" )

		local zones = uif.zones
		if dy > self.UIF_DY and zones.Slide then	--hackuif this not generic
			zone_sel = zones.Slide
			name_sel = "slide"
		else
			--todo_jean isolate this block in a fn ot even in a uif lib/object			
			for name,zone in PAIRS( zones ) do
				local a = zone.angle
				if zone.dangle then
					local da = zone.dangle*.5
					local min = a - da
					local max = a + da
					if inside( ac, min,max ) or ( min < 0 and inside( ac, min+1, max+1 ) ) then
						zone_sel = zone
						name_sel = name
						--self:print( "uif found by angle "..name )
					end
				else
					--self:print( name.." "..x.." "..y )
					local lrbt = zone.lrbt
					if lrbt then
						--self:print( name.." "..x.." in ["..lrbt.l..", "..lrbt.r.." ]" )
						if inside( x, lrbt.l, lrbt.r ) and inside( y, lrbt.b, lrbt.t ) then
							zone_sel = zone
							name_sel = name
							--self:print( "uif found by button "..name )
							break
						end
					end
				end
			end
		end
		uif.__zone_sel	= zone_sel
		name_sel = self:__process_uif_name(name_sel)
		uif.__name_sel	= name_sel

		if name_sel then
			--self:print( "uif found "..name_sel )
			if name_sel=="slide"	then
				local du	
				dy = dy-self.UIF_DY
				uif.d_manual = math.sqrt( dx*dx + dy*dy )
				local v = uif.d_manual - self.UIF_MANUAL_SIZE_MIN
				if v > 0 then
					local ac = math.atan2( dy, dx ) * math.pi2_over
					if ac < 0 then ac = ac + 1. end

					v = v / ( self.UIF_MANUAL_SIZE_ACTIVE - self.UIF_MANUAL_SIZE_MIN )
					if v > 1 then
						v = 1
					end
					du = interpolate( uif.du_last or 0, -ac + .25, v )
					--if uif.d_manual > self.UIF_MANUAL_SIZE_MIN then
					--	du = -ac + .25
				else
					du = 0
				end
				if aaa.keyboard.is_ctrl() then
					du = du * .125
					if aaa.keyboard.is_alt() then
						du = du * .125
					end
				end
				uif.__du = du
			end
			if bui then
				if bui.__get_uif_u then
					local u = bui:__get_uif_u()
					bui:__set_from_u( u )
				else
					if		name_sel=="min"	then
						--self:print( "--- Min" )
						bui:set_value_cano(0)
					elseif	name_sel=="max"	then
						--self:print( "--- Max" ) 
						bui:set_value_cano(1)
					end
				end
			end
		end
	end

	--todo remove when not used
	--todo reuse table
end


--todo deal with double interaction
function BU:draw_uif_slide( ox,oy )
	--if true then return end
	if not self.__blob_cur then return end	--in case of interuption by bug
	local bui = self.__uif_bui
	if not bui then
		self:print_error( "BU:draw_uif_slide no BUI target" )
		return
	end
	gol.set_line_smooth( true )

	--local bx,by = self.__blob_cur[1].x, self.__blob_cur[1].y
	--local x,y = self:convert_xy_bus_up_to_local( bx,by )
	--self:print( "do_mouse_move( "..x..", "..y.." )" )
--	self:do_mouse_move( x,y )

	local CSX,CSY	= .1,.1

	local id = bui:get_id_interacting()

	local uif = self:get_uif_data()
	--d = d or 0
	local x,y = uif.x,uif.y
	local xb,yb = ox + uif.x_begin, oy + uif.y_begin

	local si = self.UIF_MANUAL_SIZE_MIN*2.
	local se = self.UIF_MANUAL_SIZE_ACTIVE*2.
	local size = uif.d_manual or 0
	size = math.max( 2*size , se )

	--aaa.draw_cube(	x, y, 0, si )
	--	gol.push_matrix()
	--		gol.translate( x, y )
	--gol.scale( self:get_ratio_y(), self:get_ratio_x() )
	--gol.color_white()
	local cur = bui.__uif_val_begin --hackuif
	local u_begin = bui.__uif_val_cano_begin --hackuif
	local u = bui:get_value_cano_clamped( id )
	--gol.color_black( .8 )
	--self:gol_meter_color( .25 )
	local fa = 0.25
	local sa = 0.25 + u_begin*fa
	gol.set_line_width( 1 )
	self:gol_color_back()
	aaa.draw_disk_arc_axe_z(	xb,yb, 0, size,		sa-fa, fa,				18 )

	bui:gol_meter_color( )	--hackuif
	aaa.draw_disk_arc_axe_z(	xb,yb, 0, size,		sa-u*fa, u*fa,			18 )

	local c = self:get_uif_color( 1, true )
	local coli = {	c[1],	c[2],	c[3],	c[4]*.6	}
	local cole = {	c[1],	c[2],	c[3],	c[4]*.1	}
	gol.color( coli )
	aaa.draw_disk_arc_axe_z	(	xb,yb, 0, si,			sa-fa, fa,				12 )
	aaa.draw_annulus_grad	(	xb,yb, si*.5, se*.5,	sa-fa, sa,  coli, cole,	12 )

	local defs = bui:get_values_def_table()
	local nb = #defs
	if nb then
		local min, max = bui:get_min_max()
		for i=0,#defs do
			local def = defs[i]
			local xdef = u_begin + i*.25
			if def ~= nil then
				local span = ( max-min )
				local angle = math.abs( def-cur ) / span * .5 * math.pi
				if ( def-cur < 0 ) then
					angle = -angle
				end
				local dx = math.cos( math.pi * .5 - angle )
				local dy = math.sin( math.pi * .5 - angle )
				local dxs = dx * size * .5
				local dys = dy * size * .5
				gol.color( BU.UIF_COLOR_DEF_VALUE )
				aaa.draw_line_uv( xb,yb, dxs,dys )
				self:draw_uif_text( bui:format_value(def),        xb+dxs+dx*.1-CSX, yb+dys+dy*.1, CSX*.8, CSY*.8,   BU.UIF_COLOR_DEF_VALUE )
			end
		end
	end

	gol.color( BU.UIF_COLOR_CURRENT )
	local oys = size*.5 + CSY
	aaa.draw_line_uv( xb,yb, 0, oys )
	gol.color_black( 1. )
	aaa.draw_circle_arc_axe_z(	xb,yb, 0, si,	sa-fa-1/40, fa+1/20,	12 )
	aaa.draw_circle_arc_axe_z(	xb,yb, 0, se,	sa-fa-1/40, fa+1/20,	12 )

	self:set_uif_text_attr()

	self:draw_uif_text( bui:format_value( cur ),					xb,		yb + oys -.1,	CSX, CSY,    	BU.UIF_COLOR_CURRENT )
	self:draw_uif_text( bui:get_text(),								x-CSY,	y+2.2*CSY,		CSX, CSY,		BU.UIF_COLOR_SELECT )
	self:draw_uif_text( bui:format_value( bui:get_value( id ) ),	x-CSY,	y+CSY - .3,		CSX, CSY,		BU.UIF_COLOR_SELECT )

	--	gol.pop_matrix()
end


BU.UIF_DY					= 1/8
BU.UIF_MANUAL_SIZE_MIN		= BU.UIF_DY * 2.
BU.UIF_MANUAL_SIZE_ACTIVE	= BU.UIF_DY * 4.
BU.UIF_NEUTRAL				= BU.UIF_DY * .5
BU.UIF_COLOR_DEF_VALUE		= { .25, .75, 1, 1 }
BU.UIF_COLOR_SELECT			= { 1, 0, 1, 1 }
BU.UIF_COLOR_CURRENT		= { 1, 0, 0, 1 }

function BU:get_uif_data()		return self.__uif_data	end
function BU:set_uif_data( t )	self.__uif_data = t		end

function BU:get_uif_color( alpha, b_active )
	local c = self:get_color_named( (b_active or b_active==nil) and "uif_active" or "uif" )
	if not alpha or alpha >= 1 then		return c
	else								return { c[1], c[2], c[3], c[4]*alpha }
	end
--	return c
end
function BU:set_uif_color( alpha, b_active )
	gol.color( self:get_uif_color( alpha, b_active ) )
end

--todo make this a generic fn (no uif) passing color instead of active
function BU:draw_uif_text( str, x,y, sx,sy, color )
	if not str then return end

	local f = .075
	--	draw a "background
	--gol.set_line_width( 5 )
	gol.color_black()
	self:draw_text( str, x+sx*f, y-sy*f, sx,sy )
	--aaa.draw_str_xy( str, x-sx*f, y-sy*f, sx,sy )
	--  then draw on top
	--gol.set_line_width( 1. )
	--self:set_uif_color( 1, b_color_active )
	gol.color( color )
	self:draw_text( str, x,y, sx,sy )
	--aaa.draw_str_xy( str, x,y, sx,sy )
end

function BU:set_uif_text_attr()
	gol.set_line_width( 2 )
end

function BU:__draw_uif_back( x,y )
	--aaa.print_fn()

	local uif = self:get_uif_data()

	local r = self.UIF_DY
	-- local rm = self.UIF_NEUTRAL

	-- --todo find pixel size
	-- --gol.color_black()

	local dx = .01
	local dy = -dx
	-- --local fn = i==1 and gol.draw_line_strip_2d or gol.draw_triangle_fan_2d
	-- local fn = gol.draw_triangle_fan_2d
	-- local ph = math.sin( aaa.time.t*6.28*3 )
	local zones = uif.zones
	local FAR = 1000000
	local gl,gr, gb,gt = FAR,-FAR, FAR,-FAR
	
	-- make size of of rect including all the element of UIF
	for name,def in PAIRS( zones ) do
		--self:print( "sel is "..BU:get_uif_name_sel( uif ).." : "..name.." "..b )
		local c,s
		if def.angle == nil then
			c,s = 0,0
		else
			local a = def.angle * math.pi2
			-- local da = def.dangle and (def.dangle * math.pi2 * .5) or nil
			c,s = math.cos(a),math.sin(a)
			-- --draw arrows
			-- if da then
			-- 	set_color( b_sel, .7 )
			-- 	fn(	x + rm * c,			y + rm * s,
			-- 		x + rm*cos(a-da),	y + rm*sin(a-da),
			-- 		x + r * c,			y + r * s,
			-- 		x + rm*cos(a+da),	y + rm*sin(a+da)
			-- 		)
			-- end
		end
		
		--if not def.b_text_no and not (def.b_text_no_when_selected and b_sel) then
			--self:draw_text_visible( name,	x+c*2,	y+s*2,	r*4, r,	true )
			--local f = 2.5
			local just = def.justify or "center"
			local dist = r * ( 1. + (def.dist or 1.) )	-- size are relative to the base size of the UIF
			local xt = x + c*dist
			local yt = y + s*dist

			local rect = def.rect
			local rx =  ((rect and rect[1]) or 0) * r
			local ry =  ((rect and rect[2]) or 0) * r
			local rsx = ((rect and rect[3]) or 4) * r
			local rsy = ((rect and rect[4]) or 1) * r
			xt = xt + rx + (def.dx or 0)
			yt = yt + ry + (def.dy or 0)
			local l,r, b,t = xt-rsx/2, xt+rsx/2, yt-rsy/2, yt+rsy/2
			
			--gol.color_green( 1 )
			--aaa.draw_rect_line(	l,b, r,t )
			gl = math.min( gl, l )
			gr = math.max( gr, r )
			gb = math.min( gb, b )
			gt = math.max( gt, t )
		--end
	end

	local y_add = .05
	gb = gb - y_add
	gt = gt + y_add
	local dt = clamp_01( (aaa.time.t - uif.time_begin) * 12. ) * .5
	x,y = (gl+gr)*.5,(gb+gt)*.5
	local sx,sy = dt*(gr-gl),dt*(gt-gb)
	gl,gr = x-sx,x+sx 
	gb,gt = y-sy,y+sy

	uif.x_left		= gl
	uif.x_right		= gr
	uif.y_bottom	= gb
	uif.y_text		= gt
	uif.y_top		= gt + .15

	-- back rect
	gol.color( 0,.25,.25, .5 ) 
	aaa.draw_rect(		gl,gb, gr,uif.y_top )
	gol.set_line_width( 3 )
	-- line around rect
	gol.color_magenta( 1 )
	aaa.draw_rect_line(	gl,gb, gr,uif.y_top )
	-- line under title
	aaa.draw_line(		gl,gt, gr,uif.y_text )
end

function BU:__draw_uif_base( x,y )
	--aaa.print_fn()

	self:__draw_uif_back( x,y )

	local uif = self:get_uif_data()

	local function set_color( b_sel, alpha )
		self:set_uif_color( b_sel and 1 or alpha, b_sel )
	end

	local r =  self.UIF_DY
	local rn = self.UIF_NEUTRAL
	--local ri = r * .25
	local sin,cos = math.sin,math.cos

	--todo find pixel size
	--gol.color_black()

	local dx = .01
	local dy = -dx
	--local fn = i==1 and gol.draw_line_strip_2d or gol.draw_triangle_fan_2d
	local fn = gol.draw_triangle_fan_2d
	local ph = math.sin( aaa.time.t*6.28*3 )
	local zones = uif.zones
	
	for name,def in PAIRS( zones ) do
		local c,s
		local a,da
		if def.angle == nil then
			c,s = 0,0
		else
			a = def.angle * math.pi2
			-- local da = def.dangle and (def.dangle * math.pi2 * .5) or nil
			c,s = math.cos(a),math.sin(a)
			da = def.dangle and (def.dangle * math.pi) or nil
		end
		local b_sel = self:is_uif_name_sel( uif, name )

		-- draw arrows
		if da then
			set_color( b_sel, .7 )
			fn(	x + c         * rn,	y + s         * rn,
				x + cos(a-da) * rn,	y + sin(a-da) * rn,
				x + c         * r,	y + s         * r,
				x + cos(a+da) * rn,	y + sin(a+da) * rn
				)
		end
		
		if not def.b_text_no and not (def.b_text_no_when_selected and b_sel) then
			--self:draw_text_visible( name,	x+c*2,	y+s*2,	r*4, r,	true )
			local just = def.justify or "center"
			local dist = ( 1. + (def.dist or 1.) ) * r	-- size are relative to the base size of the UIF
			local xt = x + c * dist
			local yt = y + s * dist

			local rect = def.rect
			local rx  = ((rect and rect[1]) or 0) * r
			local ry  = ((rect and rect[2]) or 0) * r
			local rsx = ((rect and rect[3]) or 4) * r
			local rsy = ((rect and rect[4]) or 1) * r
			xt = xt + rx + (def.dx or 0)
			yt = yt + ry + (def.dy or 0)
			local l,r, b,t = xt-rsx/2, xt+rsx/2, yt-rsy/2, yt+rsy/2

			if da then
				def.lrbt = nil
			else
				-- we draw a button and store size for testing with mouse position
				def.lrbt = { l=l,r=r, b=b,t=t }
				--self:print( name.." lr is ["..def.lrbt.l..", "..def.lrbt.r.." ]" )
				if b_sel then	gol.color_green( .7 )
				else			gol.color_red( .65 + ph * .15 )
				end
				aaa.draw_rect( l,b, r,t )
			end

			self:set_uif_text_attr()
			--self:print( "in draw uif text is "..name )
			b = b + rsy*.18	-- visually ajusted
			gol.color_black( 1. )
			self:draw_text_lrbt( name, l+dx, r+dx, b+dy, t+dy, just, true )
			--self:draw_text_line( name, l,b )
			-- if b_sel then
			-- 	self:set_uif_color( 1, true )
			-- else
			-- 	self:set_uif_color( .85 + ph * .15, true )
			-- end
			set_color( b_sel, 1. )
			self:draw_text_lrbt( name, l,r, b,t, just, true )
			--self:draw_text_line( name, l,b, dx*10,dy*10 )
			--todo needed because if text : remove
			--gol.set_blend_add()
			--aaa.draw_null_2d( l,b,0, .05 )
			--aaa.draw_null_2d( r,t,0, .05 )
			--aaa.draw_mul_line( (l+r)/2,(b+t)/2, (r-l)/2, (t-b)/2 )
		end
	end

	local just = "center"
	local str = self:get_uif_name()
	local l,r = uif.x_left, uif.x_right
	local t = uif.y_top
	local b = uif.y_text
	local oy = (t-b)/8
	
	gol.color_black( 1. )
	self:draw_text_lrbt( str, l+dx,r+dx, b+oy+dy,t+dy, just, true )
	gol.color_white()
	--self:set_uif_color( 1, true )
	self:draw_text_lrbt( str, l,r, b+oy,t, just, true )
end

function BU:get_uif_name()
	return self:get_name()
end

--todo deal with double interaction
function BU:draw_uif()
	local uif = self:get_uif_data()
	if not uif then return end

	gol.reset()
	--local s_text_type_last = BU.__s_text_type
	--BU.__s_text_type = 3
	local tt = self:get_text_type()
	self:set_text_nice()

		self:__draw_uif_base( uif.x_begin, uif.y_begin )

		local name_sel = BU:get_uif_name_sel( uif )
		if name_sel == "slide" then
			self:draw_uif_slide( 0, self.UIF_DY )
		end

		self:set_uif_color( 1, name_sel~=nil )
		--gol.color( BU.UIF_COLOR_SELECT )
		aaa.draw_null( uif.x, uif.y, 0, self.UIF_DY * (1.2+.2*math.sin(aaa.time.t*10)) )

	self:set_text_type( tt )
	--BU.__s_text_type = s_text_type_last
end
