-- BIND 
-- these fns finction with the ref table but have no connection with interface
function MEU:get_bind_2d()
	local ref = self.ref
	if ref.layer and ref.bank_2d then
		return aaa.img.make_bind_2d( param.get( ref.bank_2d ), param.get( ref.bind_2d ) )
	end
end

function MEU:set_bind_2d( bind, id )
	--aaa.print_fn()
	local maps = self.ref.map
	--table.print( maps, "maps", 2 )
	if maps then
		id = id or 1
		local map = maps[id]
		if map then
			local pset = param.set
			if bind then
				local ba,bi = aaa.img.make_bank_bind_2d( bind )
				--aaa.print_method()
				pset( map.bank_2d, ba )
				pset( map.bind_2d, bi )
			else
				if id == 1 then
					pset( map.bank_2d, -1 )
					pset( map.bind_2d, -1 )
				end
			end
		else
			table.print( self.ref.map, "maps", 2 )
			self:print_error( "MEU:set_bind_2d() no ref map for id "..id )
		end
	else
		self:print_error( "MEU:set_bind_2d() no ref.map" )
	end
end

-- BIND considering the BU_TEXTURE
--	
--

function MEU:get_texture_size( id )
	local bind = self:get_texture_bind_2d( id )
	--self:print( "bind "..bind ) 
	if bind then return aaa.img.get_size( bind ) end
end
function MEU:get_texture_ratio_x( id )
	local sx,sy = self:get_texture_size( id )
	return sy and sx/sy or 1
end
function MEU:get_texture_ratio_y( id )
	local sx,sy = self:get_texture_size( id )
	return sx and sy/sx or 1
end

function MEU:set_texture_bind_2d( id, bind )
	if bind then
		--todo clean and optimize
		local bu_tex = self:get_bu_texture( id )
		--aaa.print_fn()
		if bu_tex then
			bu_tex:set_bind_2d(bind)
		end
	end
end
function MEU:get_texture_bind_2d( id )
	--self:print( "before" )
	local bu_tex = self:get_bu_texture( id )
	--self:print( "after bu_tex "..bu_tex )
	if bu_tex then
		--self:print( "before get_bind_2d()" )
		return bu_tex:get_bind_2d()
	end
	--self:print( "use backup" )
	return self:get_bind_2d()
end

function MEU:get_texture_dim()
	local bu_tex = self:get_bu_texture( id )
	if bu_tex then
		return bu_tex:get_dim()
	end
end
--tmp hack for maa
--used for live debug only
function MEU:get_texture_bind_hack( id )
	local b_debug = false -- id > 100
	if id > 100 then
		id = id - 100
	end
	local bu_tex = self:get_bu_texture( id )
	if b_debug then
		aaa.print_fn()
		table.print( bu_tex, "bu_tex in MEU:get_texture_bind_hack()" )
	end
	if bu_tex then
		--aaa.print_fn()
		if bu_tex.bu.bank then
			local bank, bind = bu_tex.bu.bank:get_value(), bu_tex.bu.bind:get_value()
			--self:print( "bank "..bank.." bind "..bind )
			--self:print( aaa.img.make_bind_2d( bank, bind ) )
			return aaa.img.make_bind_2d( bank, bind )
		else
			self:print( "No bu.bank, id is "..id )
			table.print(  bu_tex, "bu_tex table is", 3 )
			aaa.debug.print_traceback()
		end
	else
		-- if id ~= 1 then
		-- 	self:print(  "No bu_tex, id is "..id )
		-- 	aaa.debug.print_traceback()	
		-- end
	end
	return self:get_bind_2d()
end
function MEU:swap_texture_bind( id_a, id_b )
	local bind_a,bind_b = self:get_texture_bind_2d(id_a),self:get_texture_bind_2d(id_b)
	self:set_texture_bind_2d( id_a, bind_b )
	self:set_texture_bind_2d( id_b, bind_a )
end
--todo now used in facetrak only
function MEU:get_texture_bank_bind( id )
	local bu_tex = self:get_bu_texture( id )
	if bu_tex then
		return bu_tex:get_bank_bind_2d()
	end
end
--[[unused 2024 Sep
function MEU:get_texture_dim( id )
	--aaa.print_fn()
	local bu_tex = self:get_bu_texture( id )
	if bu_tex then
		if bu_tex.bu.dim then
			return bu_tex.bu.dim:get_value()
		end
	end
	self:print(  "No bu.dim, id is "..id )
	table.print(  bu_tex, "bu_tex table is", 3 )
	aaa.debug.print_traceback()
end
--]]
function MEU:bind_texture_to_unit( id, unit_index )
	gol.set_tex_unit_2d_bind( unit_index or (id - 1), self:get_texture_bind_2d( id ) )
end

-- BU_TEXTURE storage
--
--todotex we should move to bus level to store bu_texture
function MEU:free_bu_texture()
	--todo put it in BUS
	self.__bu_textures = nil
end

function MEU:__store_bu_texture( id, bu_texture )
	if not id then
		self:box_debug( "Houston no id calling MEU:__store_bu_texture()")
		id = 1
	end
	-- create new tex table when needed
	local textures = rawget( self, "__bu_textures" )	-- we don't want to confuse with instance proto 
	if not textures then
		textures = {}
		self.__bu_textures = textures
	end

	-- erase tex[id] if it exist to avoid problem when we redef
	if textures[id] then
		self:error( "MEU.__bu_textures["..id.."] already exist this should not happen" )
		-- we never pass here
	end

	textures[id] = bu_texture
	return bu_texture
end


function MEU:get_bu_texture( id )
	local tex = rawget( self, "__bu_textures" )	-- we don't want to confuse with instance proto 
	if tex then
		return tex[id or 1]
	end
end



-- function MEU:set_ui_tex_bank_bind( id, bank, bind )
-- 	--todo clean and optimize
-- 	local bu_tex = self:get_bu_texture( id )
-- 	if bu_tex then
-- 		if not bank then
-- 			bank, bind = aaa.img.make_bank_bind_2d( bind )
-- 		end
-- 		bu_tex.bu.bank:set_value( bank )
-- 		bu_tex.bu.bind:set_value( bind )
-- 	end
-- end
-- function MEU:set_ui_tex_bank_bind_save( id, b )
-- 	local bu_tex = self:get_bu_texture( id )
-- 	if bu_tex then
-- 		--todo Maa done too much here in a rush
-- 		--self:print( "value is  "..b  )
-- 		bu_tex.bu.bank:set_value_load_save( b )
-- 		bu_tex.bu.bank:set_pos_load_save(false)	--hack to be sure
-- 		bu_tex.bu.bind:set_value_load_save( b )
-- 		bu_tex.bu.bind:set_pos_load_save(false)	--hack to be sure
-- 	end
-- end

function MEU:set_bu_texture_preset_use( id, b_use )
	 local bu_tex = self:get_bu_texture( id )
	 if bu_tex then
		bu_tex:set_preset_use( b_use )
	end
end
--todo how do we deal with dim or even monitor
function MEU:set_bu_texture_save( id, b )
	local bu_tex = self:get_bu_texture( id )
	--table.print( bu_tex.bu.bank.__balues, "bu_tex.bu.bank.__balues", 3 )
	if bu_tex then
		bu_tex:set_value_load_save( b )
		self.__bu_ui.b_build_preset_needed = true	--todo force rebuild of list should be isolated later
	end
end

--todonow clean, used just for Sitem
function MEU:set_ui_tex_src_sel( id, value )
	aaa.print_fn()
	self:get_bu_texture( id ).bu.src_sel:set_value( value )
end



--TEXS prepare for hierarchy
function MEU:get_tex_named()
	return TEXS:get_tex_named()
--	local tab = MEU.__bind_tex
--	return tab and tab or MEU:__init_tex_named()
end
function MEU:get_bind_by_name( name )			return TEXS:get_bind_by_name( name )	end
function MEU:get_name_from_bind( bind )			return TEXS:get_name_from_bind( bind )	end

--[[ if use have to be updated
local function sel_tex_src_min( bu, balue )
	local value = balue:get_value()
	aaa.print( "sel_tex_src_min() value is "..value )
	local src = MEU.__src_video_bind_list[ value + 1 ];
	if src then
		bu.__target_monitor:set_texture_bind_2d( src+96 )
	end
end
--]]

function MEU:load_texture( id )
	--aaa.print_fn()
	local bind = self:get_texture_bind_2d( id )
	TEXS:load_texture( bind )
end

function MEU:__add_bu_texture( rect, name, id, b_dim_or_x_skip,	target_lua_table,	layer_or_tex_unit,	mapping )
	id = id or 1

	local ix = (rect and rect[1]) or 1
	local sx = (rect and rect[3]) or 8
	local sy = (rect and rect[4]) or 3.5
	local iy = (rect and rect[2]) or (1.2 + (id-1) * sy)
	local b_compact
	if rect then b_compact = rect.b_compact end

	name = name or "Tex"

	local bu = self:create_add_bu(	BU_TEXTURE, name, {ix,iy, sx,sy}, id, b_dim_or_x_skip )
	self:__store_bu_texture( id, bu )

	if target_lua_table then
		bu:set_target_lua( target_lua_table )
	end

	if layer_or_tex_unit then
		bu:set_target_layer( layer_or_tex_unit,	mapping )
	end

	return bu
end


--we pass a layer_ref or it just like add_bu_texture
MEU.doc.add_bu_texture_target_layer = "( {x,y, sx,sy}, name, id,	b_dim_or_x_skip, layer, mapping )\n"..
									"same than add_bu_texture_target_unit() but we can pass layer and maaping explicitly"
function MEU:add_bu_texture_target_layer(		rect, name, id,	b_dim_or_x_skip,			layer, mapping )
	if layer == nil then
		self:print_error( ":add_bu_texture_target_layer() argument layer should not be nil" )
	else
		local class = aaa.obj.get_class(layer)
		if class~="layer" then
			self:print_error( ":add_bu_texture_target_layer() argument 5 should be a layer not a "..class.."\n filename "..aaa.obj.get_filename(layer) )
		end
	end
	return self:__add_bu_texture( 			rect, name, id, b_dim_or_x_skip,	nil,	layer, mapping )
end

-----------------------------------------------------------------------------------------------------------------------------------------------------
MEU.doc.add_bu_texture_target_unit = "( {x,y, sx,sy}, name, id,	b_dim_or_x_skip )\n"..
									"nil b_dim_or_x_skip will be considered as true\n"..
									"the corresponding texture unit () going thru the MEU ref table will be used as target\n"..
									"so most of the time it will be from layer A/1\n"..
									"use set/get_bind_2d() to access it"
function MEU:add_bu_texture_target_unit(		rect, name, id,	b_dim_or_x_skip,			arg5	)
	if arg5~=nil then
		self:print_error( "MEU:add_bu_texture_target_unit() argument 5 ignored: wrong method called ?")
	end
	id = id or 1
	if b_dim_or_x_skip==nil then b_dim_or_x_skip = true end
	local ref = self.ref
	if id==1 then	--we do it with layer and mapping
		return self:add_bu_texture_target_layer(rect, name, id,	b_dim_or_x_skip,	ref.__layer_marked,		self.ref.mapping	)
	else			-- or we use the texturing part of layer
		--table.print( ref, "ref", 2 )
		local ref_tex_unit = ref["tex_unit_"..(id-1)]
		--self:print( "tex_unit_"..id.." -> "..ref_tex_unit )
		if not ref_tex_unit then
			--todotex		
			self:print_error( "No ref_tex_unit for id "..id.." solve what we do here" )
		end
		return self:__add_bu_texture( 		rect, name, id, b_dim_or_x_skip,	nil,	ref_tex_unit )
	end
end
MEU.doc.add_bu_texture_target_unit_nb = "( {x,y, sx,sy}, pre, nb_u,nb_v )"
function MEU:add_bu_texture_target_unit_nb(		rect,	pre,	nb_u,nb_v )
	local x,y, sx,sy = rect[1],rect[2], rect[3],rect[4]
	rect.b_compact = true
	sx = sx/nb_u
	rect[3] = sx
	sy = sy/nb_v
	rect[4] = sy
	local id = 1
	for iv=1,nb_v do
		rect[1] = x	
		for iu=1,nb_u do
			self:add_bu_texture_target_unit(	rect, pre..id, id, false )
			rect[1] = rect[1] + sx	
			id = id + 1
		end
		rect[2] = rect[2] + sy
	end
end
-----------------------------------------------------------------------------------------------------------------------------------------------------
MEU.doc.add_bu_texture = "( {x,y, sx,sy}, name, id, b_dim_or_x_skip )\n"..
						"nil b_dim_or_x_skip will be considered as false\n"..
						"just add a standard texture interface with no other automatism\n"..
						"use set/get_bind_2d() to access it"
function MEU:add_bu_texture(		rect, name, id, b_dim_or_x_skip,	arg5	)
	if arg5~=nil then
		self:print_error( "MEU:add_bu_texture() argument 5 ignored: wrong method called ?")
	end
	return self:__add_bu_texture(	rect, name, id, b_dim_or_x_skip )
end

-----------------------------------------------------------------------------------------------------------------------------------------------------
MEU.doc.add_texture_button = "( {x,y, sx,sy}, name )\n"..
						"just add a button with the same Shortcut selector than a BU_TEXTURE\n"..
						"use get_bind_2d() get the nind_2d of the selected one"
function MEU:add_texture_button( rect, name )
	local bu = self:add_button( rect, name, nil, nil, 3 ) -- 3 is value
	TEXS:define_src_menu( bu )
	bu:set_value_load_save( false )
	bu.get_bind_2d = bu.get_item_data
 	return bu
end
MEU.doc.add_texture_selector = "( {x,y, sx,sy}, name )\n"..
						"just add a selector with some predefined choice for bind\n"..
						"use get_bind_2d() get the bind_2d of the selected one"
function MEU:add_texture_selector( rect, name, id, row_nb )
	local channel_name  = TEXS._t_dst_bind_text
	local channel_symbo = TEXS._t_dst_bind_symbo
	
	local bu = self:add_selector( rect, name )

	local nb = #channel_name

	bu:set_preset_use( false )		--todo we should do a mecanism to load when not in contradiction with bind and bank
	row_nb = row_nb or 3
	bu:set_nb_min_0( nb/row_nb, row_nb )

	bu:set_item_text( 1, unpack(channel_name) )
	-- for i=1,nb do		
	-- 	--self:print( name.." - "..TEXS:get_bind_by_name( name ) )
	-- 	bu:set_item_data( i, self:get_bind_by_name( channel_symbo[i] ) )
	-- end

	bu.__get_bind_2d = function(bu) return self:get_bind_by_name( channel_symbo[bu:get_value()+1] ) end
	if true then	--one way to do it
		bu.get_bind_2d = bu.__get_bind_2d
	else			--a more optimize for time way
		bu:set_hook_on_value_change( function( bu, balue ) bu.__sel_bind_2d = bu:__get_bind_2d() end )
		bu.get_bind_2d = function(bu) return bu.__sel_bind_2d end
	end
	return bu
end

--[[
function BIND_TEX.__set_from_selector( bu, balue )
	--when reading preset we don't want to change anything
	if bu.meu:is_preset_recalling() then
		return
	end

	--we just do it with interaction : don't function no contact yet on first click
	--if bu:is_contact() then

	local meu = bu.meu
	if meu then
		local bind = bu:get_item_data()
		aaa.print( "BIND_TEX.__set_from_selector() bind is "..bind )
		meu:set_texture_bind_2d( bu.__tex_id, bind )
	end
	--end
end
--]]




--[[ unused now 2024 Sep : kjept for reference a while
function MEU:__set_src_from_selector( bu_sel, id ) --todotex
	--when reading preset we don't want to change anything
	if self:is_preset_recalling() then
		return
	end
	--we just do it with interaction : don't function no contact yet on first click
	--if bu:is_contact() then
		local bind = bu_sel:get_item_data()
		aaa.print( "MEU:__set_src_from_selector() bind is "..bind )
		self:set_texture_bind_2d( id, bind )
	--end
end

-- target_lua_table and layer_or_tex_unit are mutually exclusive
function MEU:__add_tex_bind(				rect, 	name, id,	 b_dim_or_x_skip,	target_lua_table,	layer_or_tex_unit,	mapping )
	if MEU.__b_bu_texture_use then
		return self:__add_bu_texture(		rect, 	name, id,	 b_dim_or_x_skip,	target_lua_table,	layer_or_tex_unit,	mapping )
	end

	--aaa.print_fn()
	-- VERBOSE / DEBUG
	if self.__b_bu_texture_verbose then
		aaa.print_fn()
		if layer_or_tex_unit then
			self:print( "__add_bu_texture(): layer_or_tex_unit is "..aaa.obj.get_filename(layer_or_tex_unit) )
		elseif target_lua_table then
			self:print( "__add_bu_texture(): we have a target_lua_table" )
			table.print( target_lua_table, "target_lua_table", 2 )
		else
			self:print( "__add_bu_texture(): no layer_or_tex_unit or target_lua_table" )
		end
		self:box_debug( "Verbose" )
	end

	--todo regroup as a window
	id = id or 1
	local b_dim
	if type(b_dim_or_x_skip)=="boolean" then
		b_dim = b_dim_or_x_skip
	else
		b_dim = false
	end

	local ix = (rect and rect[1]) or 1
	local SX = (rect and rect[3]) or 8
	local SY = (rect and rect[4]) or 3.5
	local iy = (rect and rect[2]) or (1.2 + (id-1) * SY)

	local b_compact
	if rect and rect.b_compact~=nil then
		b_compact = rect.b_compact
	else
		b_compact = true
	end 
	--table.print( rect, "rect in MEU:__add_bu_texture()" )

	--avoid same names
	--todo we should move to Tex_dim by default even go further, keep on the hacks for now
	local text_dim = "dim"
	if name then
		text_dim = name.."_"..text_dim
	else
		name = name or "TEX"
	end

	local nb_bank_line = BU_TEXTURE:get_bank_line()

	local HMARGIN = self.__HMARGIN

--todo
--we store stuff here, this should be a BU_TEX later
-- in particular the BUs
	local tex = self:__store_bu_texture( id )

	local bu
	local sx

	local sel_bank, sel_bind, sel_dim, bu_monitor, bu_src
	local sx_src = 2.4

--BANK BIND SELECTOR
	local function add_selector_bank_bind( rect, post, nbx,nby )
		local bu = self:add_selector( rect, name.."_"..post )
		tex.bu[post] = bu
		bu:set_text_draw( false )

		post = post.."_2d"
		if target_lua_table then
			bu:set_target_lua( target_lua_table, "__"..post )
			tex.target_lua_table = target_lua_table
		elseif layer_or_tex_unit then
			--self:print( layer_or_tex_unit.." post is "..post )
			local par = param.get_ref( layer_or_tex_unit, post )
			--self:print( "par is "..par )
			--table.print( bu.__balues, "tex.bu.bank.__balues", 3 )
			--self:box_debug( "before" )
			bu:set_target_param( par )	--todo not needed and buggy here
			--table.print( bu.__balues, "tex.bu.bank.__balues", 3 )
			--self:box_debug( "after" )
			tex.layer_or_tex_unit = layer_or_tex_unit
			tex.ref_bind_2d_out = param.get_ref( layer_or_tex_unit, "bind_2d_out" )
		end
		bu:set_nb_min_0( nbx, nby )
		bu:set_method_on_click_double( self, "load_texture", id )
		return bu
	end

	local function add_button_menu( rect, post, nbx,nby )
		local bu = self:add_button(	rect, name.."_"..post )
		--bu:set_value_load_save( false )
		tex.bu[post] = bu

		local sel = SELECTOR:create( name.."_"..post )
		sel:set_text_draw( false )
		sel:set_nb_min_0( nbx, nby )
		bu:set_menu( sel )

		post = post.."_2d"
		if target_lua_table then
			sel:set_target_lua( target_lua_table, "__"..post )
			tex.target_lua_table = target_lua_table
		elseif layer_or_tex_unit then
			--self:print( layer_or_tex_unit.." post is "..post )
			local par = param.get_ref( layer_or_tex_unit, post )
			--self:print( "par is "..par )
			sel:set_target_param( par )	--todo not needed and buggy here
			tex.layer_or_tex_unit = layer_or_tex_unit
			tex.ref_bind_2d_out = param.get_ref( layer_or_tex_unit, "bind_2d_out" )
		end
		sel:set_method_on_click_double( self, "load_texture", id )

		return sel, bu
	end

	if b_compact then
		local SX_MONITOR 	= 	SX
		local SYB			=	math.min( .8, SY/5 )
		local SY_MONITOR 	= 	SY-SYB

		local SX_BANK		=	SX * 1.2/8
		local SX_DIM

		if type(b_dim_or_x_skip)=="number" then
			SX_DIM = b_dim_or_x_skip
		else
			SX_DIM = b_dim and SX_BANK or 0
		end

		local Y_TOP	=	iy 	--	- Y_TOP + self.__HMARGIN
		local Y_BOT	=	iy + SY + self.__HMARGIN
		local Y_MID	=	Y_BOT + SY*3
		--FLUX SELECTOR
		bu_src = self:add_texture_button(	{ix+SX_DIM, iy,		SX-SX_DIM-SX_BANK*2, SYB},	name, id )

		sx = SX-SX_MONITOR-HMARGIN
		sel_bank, bu = add_button_menu(	{ix+SX-SX_BANK*2, iy,	SX_BANK, SYB},	"bank",		16,nb_bank_line/2 )
			bu:set_text_inside( true )
			bu:set_text_selector( true )
			TEXS:adjust_bank_selector( sel_bank, 16, nb_bank_line/2 )

		sel_bind, bu = add_button_menu(	{ix+SX-SX_BANK, iy,		SX_BANK, SYB},	"bind",		8,4 )
			bu:set_text_inside( true )
			bu:set_text_selector( true )
			TEXS:adjust_bind_selector( sel_bind, 8, 4 )

		if b_dim then
			bu = self:add_button(	{ix,iy, SX_DIM,SYB }, text_dim )

				sel_dim = SELECTOR:create( text_dim.." sel" )
					sel_dim:set_text_draw( false )
					sel_dim:set_nb_min_0( 4 )

				bu:set_menu( sel_dim )
				bu:set_text_selector( true )
				bu:set_text_inside( true )
		end

		if SX_MONITOR>0 then
			bu_monitor = self:add_monitor_id( {ix+HMARGIN, iy+SYB,		SX_MONITOR, SY_MONITOR},	name.."_monitor", id )
		end
	else
		local SY_MONITOR 	= 	SY
		local SYB			=	SY/4
		local SYS 			= 	SY - SYB

		local SX_MONITOR 	= 	4/8 * SX
		local SX_REST		=	SX - SX_MONITOR
		local SX_DIM 		=   b_dim and SX_REST*3/8 or 0
		local X_LEFT		=	ix + SX_MONITOR

		local Y_TOP			=	iy - SY + self.__HMARGIN
		local Y_BOT			=	Y_TOP + SY + self.__HMARGIN
		local Y_MID			=	Y_BOT + SYB
		local SX_BANK		= 	SX_REST/2
		local X_SPLIT		= 	(SX-SX_BANK)
		sel_bank = add_selector_bank_bind(	{X_LEFT,		Y_MID,	SX_BANK,SYS},	"bank",		8,nb_bank_line )
			TEXS:adjust_bank_selector( sel_bank, 8, nb_bank_line )
		sel_bind = add_selector_bank_bind(	{X_LEFT+SX_BANK,Y_MID,	SX_BANK,SYS},	"bind",		8,4	)
			TEXS:adjust_bind_selector( sel_bind, 8, 4 )
			for i=1,4 do	sel_bind:set_item_text( (i-1)*8+1,	(i-1)*8+0	)	end
		if b_dim then
			sel_dim = self:add_selector(	{X_LEFT,		Y_BOT,	SX_DIM,SYB},	text_dim	)
		end
		if SX_MONITOR>0 then
			bu_monitor = self:add_monitor_id( {ix, Y_BOT, SX_MONITOR, SY_MONITOR}, name.."_monitor", id )
		end
		--FLUX SELECTOR
		bu_src = self:add_texture_button( {X_LEFT+SX_DIM, Y_BOT,	SX_REST-SX_DIM, SYB}, name, id )
	end

	bu_src:set_text_inside( true )
--DIM SELECTOR
	if sel_dim then
		tex.bu.dim = sel_dim
		sel_dim:set_text_draw( false )
		sel_dim:set_nb_min_0( 4 )
		sel_dim:set_item_text(	1,	"no", "1D",	"2D", "3D"	)
		if target_lua_table then
			sel_dim:set_target_lua( target_lua_table, "__dim" )
		elseif mapping then	--refine the else and check mutual exclusion
			sel_dim:set_target_obj_param( mapping, "tex_use" )
		end
	-- else
	-- 	if target_lua_table then
	-- 		target_lua_table.dim = 2
	-- 	end
	end

--	MONITOR
	if bu_monitor then
		bu_monitor:set_text( name )
		bu_monitor:set_info_size_fxy( 2, 2. )
		bu_monitor:__delegate_get_set_bind_2d( self, "get_texture_bind_2d", "set_texture_bind_2d", id )
		tex.bu.monitor = bu_monitor	--todo seems unused for now M6aa 2023 Feb
	end

	tex.bu.src_sel = bu_src

	if self.__b_bu_texture_verbose then
		self:print( "we exit MEU:__add_bu_texture() now" )
		table.print( tex, "tex", 1 )
		table.print( self:get_bu_texture(id), "self:get_bu_texture", 1 )
		self:box_debug( "Verbose" )
	end

	return tex
end
--]]
