--	CAMERA
--
function MEU:get_camera_used()
	local layers = self:get_layers()	--todo what happened when it is not the case
	--todoaqua refine for module
	return layers and aaa.layers.get_camera( layers )
end
function MEU:get_camera( id )
	local layers = self:get_layers()	--todo what happened when it is not the case
	--todoaqua refine for module
	return layers and aaa.layers.get_camera( layers, id )
end
function MEU:get_camera_sel()
	local bu = self.ui.bu_cam_sel
	if bu then	--protect in some initialisation scenarios
		local sel = bu:get_value()
		--todoaqua refine for module
		return self:get_camera( sel+1 )
	end
end
function MEU:__update_camera_sel()
	--aaa.print_method()
	local ui = self.ui
	--self:print( ui.bu_cam_use:get_value() )
	local cam = self:get_camera_sel()
	--self:print( "__update_camera_sel -> "..sel.." "..cam )
	local r = param.get_ref( cam, "draw_axe" )
	param.set( r, ui.bu_cam_show:get_value() )
	param.set_save( r, false )

	local gp = app:get_gp()
	if not gp.b_rendering then
		if ui.bu_cam_use:get_value() > 0 then
			aaa.obj.become_ui( cam )	
		end
	end
end

function MEU:__focus_camera()
	--aaa.print_method()
	local cam = self:get_camera_sel()
	--self:print( "__focus_camera -> "..sel.." "..cam )
	aaa.obj.set_focus_ui( cam )
end
function MEU:__set_ui_camera()
	--aaa.print_method()
	local cam = self:get_camera_sel()
	--self:print( "__set_ui_camera -> "..sel.." "..cam )
	if cam then	-- protect in some initialisation scenarios
		aaa.obj.become_ui( cam )
	end
end
MEU.doc.__camera_do_click_down = "(x,y) used to copy camera"
function MEU:__camera_do_click_down( x,y )
	local bu = self
	self = bu.__meu
	SELECTOR.do_click_down( bu, x,y )
	--aaa.print_fn()
	aaa.print( "ctrl "..aaa.keyboard.is_ctrl() )
	if aaa.keyboard.is_ctrl() then
		local src = MEU.__cam_last_picked
		if src then
			local sel = bu:get_value()
			--aaa.print( "sel "..sel )
			local dst = self:get_camera( sel+1 )
			aaa.obj.set_param_from( dst, src )
		end
	elseif aaa.keyboard.is_shift() then
		local sel = bu:get_value()
		--aaa.print( "sel "..sel )
		local dst = self:get_camera( sel+1 )
		param.flip( dst, "ui_lock" )
		--todoundo add the undo redo code
	end
end
MEU.doc.__camera_do_click_up = "( x,y ) used to copy camera"--	tab.add_param_size = ""
function MEU:__camera_do_click_up( x,y )
	local bu = self
	self = bu.__meu
	SELECTOR.do_click_up( bu, x,y )
	local sel = bu:get_value()
	--aaa.print( "Store cam "..sel.." ref for copy " )
	MEU.__cam_last_picked = self:get_camera( sel+1 )
end

function MEU:__update_ui_cam()
	local ui = self.ui
	local val = ui.bu_cam_use:get_value()
	local bu_cam = ui.bu_cam_sel
	--self:print( "cam is "..b )
	local a
	if val>0 then
		bu_cam:set_color_back( "bui" )
		a = bu_cam:interpolate_alpha_bu( 1 )
	else
		bu_cam:set_color_back( "none" )
		a = bu_cam:interpolate_alpha_bu( .25 )
	end
	ui.bu_cam_show:set_alpha_bu( a )
end

local function draw_camera_items( self )
	local x,y
	local dx = self.__nb_u_over
	local dy = self.__nb_v_over
	gol.color_red( .5 * self:get_alpha_bu() )

	local meu = self.__meu
	for i = 1,self:get_nb() do
		local cam = meu:get_camera( i )
		if param.get_bool( cam, "ui_lock" ) then
			x,y = self:get_item_lb(i)
			aaa.draw_rect( x,y, x+dx,y+dy )
		end
	end
	gol.color_white( .5 * self:get_alpha_bu() )
	local i_sel = self:get_item_sel()
	x,y = self:get_item_lb(i_sel)
	aaa.draw_rect( x,y, x+dx,y+dy )
end


function MEU:add_camera( rect, nb, b_force_no )	
	nb = nb or 8
	local b_line_more = nb>=12
	local sy_def = b_line_more and 1.4 or 1
	local ix,iy, sx,sy = self:unpack_rect_using_def( rect, {9,1, 8,sy_def} )

	local bu
	local par

	--	this one define if we use a current camera or define our own (already in AAA flaatland infact)
	bu = self:add_selector(	{ix,iy,	1,sy}, "cam_use" )
		bu:set_nb( 1, 3 )
		bu:set_item_text( 1, "No", "Once", "Owner" )
		--todo deal with MEU module
		par = param.get_ref( self:get_layers(), "use_camera" )
		bu:set_target_param( par )
		bu:set_text_draw( false )
		if b_force_no then
			bu:set_value( 0 )
		end
		bu:set_method_on_value_change( self, "__update_camera_sel" )
		bu:set_preset_use( false )

		self.ui.bu_cam_use = bu

	--	this one define if we show the current axis  (already in AAA flaatland infact)
	bu = self:add_button(	{ix + sx-1,iy, 1-.08,sy}, "cam_axe_show" )
		bu:set_text_draw( false )
		bu:set_text_inside( false )
--		bu:set_text_inside( "Axe" )
		bu:set_method_on_value_change( self, "__update_camera_sel" )
		bu:set_preset_use( false )
		self.ui.bu_cam_show = bu

	--	we choose one cam among 8
	bu = self:add_selector(	{ix + 1,iy,	sx-2,sy}, "cam_index" )
		--todo deal with MEU module
		par = param.get_ref( self:get_layers(), "camera_index_ui" )
		bu:set_target_param( par )

		--have to be after set_target_param
		if b_line_more then
			bu:set_nb_min_0( nb/2, 2 )
		else
			bu:set_nb_min_0( nb )
		end
		bu:set_item_text_from_nb_minus_1( 2 )
		bu:disable_mobile()

		bu:set_method_on_value_change(	self, "__update_camera_sel" )	
		bu:set_method_on_click(			self, "__set_ui_camera" )
		bu:set_method_on_click_double(	self, "__focus_camera" )
		self.ui.bu_cam_sel = bu

		bu.do_click_down 	= self.__camera_do_click_down
		bu.do_click_up		= self.__camera_do_click_up
		bu.draw_items		= draw_camera_items
		bu.__meu = self

		--bu:print( "max is "..bu:get_max() )
		self:register_update_ui( "__update_ui_cam" )
	return bu
end

function MEU:set_screen_viewport( value )
	local cam = self:get_camera_used()
--hackjan2015
-- do we need a special mecanism
	if cam then
		aaa.screen.set_camera( cam, value )	--todo better than ( MEU.__screen_offset or 0 ) )
	end
end
function MEU:update_screen_viewport_from_bu( bu )
	self:set_screen_viewport( bu:get_value() )
end


-- function MEU:get_screen_viewport_sxy()
-- 	local id = self.ui.bu_screen_id:get_value()
-- 	local l,b, r,t = aaa.screen.get_viewport_cano(id)
-- 	local sx,sy = r-l, b-t
-- 	if sx~=0 and sy~=0 then
-- 		return sx,sy
-- 	end
-- end
-- function MEU:get_screen_viewport_ratio_x()
-- 	local sx,sy = self:get_screen_viewport_sxy()
-- 	if sy then
-- 		return sx/sy
-- 	end
-- end
-- function MEU:get_screen_viewport_ratio_y()
-- 	local sx,sy = self:get_screen_viewport_sxy()
-- 	if sy then
-- 		return sy/sx
-- 	end
-- end
function MEU:add_screen_viewport( ix, iy )
	ix = ix or 10
	iy = iy or 2

	local bu = self:add_selector(	{ix,iy,	6,1}, "screen_dst" )
		bu:set_nb_min_0( 7 )
		bu:set_item_text( 1, "Full" )
		bu:set_item_text_from_nb_minus_1( 2 )
		bu:disable_mobile()
		bu:set_method_on_value_change( self, "update_screen_viewport_from_bu", bu )
		self.ui.bu_screen_id = bu
end
